// inv_rec1.cpp
// 4/4/99
// Demo of struct
// Ken Brownsey


#include "iostream.h"
#include "rd_str.h"

#define HighBalance 2000.0


typedef enum	Dept_T {Toys, Food, Clothing};

typedef int InvNum_T;
typedef float Balance_T;

typedef struct {
	InvNum_T		InvoiceNum;
	Balance_T	Balance;
	enum 	Dept_T Dept;
} InvRec_T;


// PRE	TRUE
// POST	Prompts user for department by number
//		and returns mode read in defaulting to Food */
enum Dept_T
Read_Dept() {
	int	InData;
	Dept_T Result;

	cout	<< "\nToys please enter 1 ";
	cout	<< "\nFood please enter 2 ";
	cout	<< "\nClothing please enter 3 ";
	cout	<< "\n ====>  ";
	cin	>> InData;
	switch (InData) {

		case 1:
			Result = Toys;
		break;
		case 2:
			Result = Food;
		break;
		case 3:
			Result = Clothing;
		break;
		default:
			Result = Food;
		break;
	}
	return(Result);
}


// PRE	Dept has a valid value
// POST	Prints string for Dept
void
Write_Dept(enum Dept_T Dept) {
	switch(Dept) {

		case Toys:
			cout << "\nToys and Games";
		break;
		case Food:
			cout	<< "\nFood and Drink";
		break;
		case Clothing:
			cout	<< "\nClothing and Bedding";
		break;
		default:
		break;
	}
}



//	PRE	TRUE
//	POST	prompts user for invoice record
//			which is read into InvRec
void
Read_Rec(InvRec_T &InvRec) {

	cout	<< "\nInvoice Number ==> ";
	cin	>> InvRec.InvoiceNum;
	cout	<< "\nBalance ==> ";
	cin	>> InvRec.Balance;
	cout	<< "\nDepartment ";
	InvRec.Dept = Read_Dept();
}



/*	PRE	TRUE */
/*	POST	writes Rec to screen */
void
Write_Rec(InvRec_T Rec) {

	cout	<< "\nInvoice Number is "
			<< Rec.InvoiceNum
			<< "\nBalance is "
			<< Rec.Balance
			<< "\nDept is ";
	Write_Dept(Rec.Dept);
	cout	<< "\n";
}


// PRE	TRUE
// POST	IF Rec balance greater than HighBalance warning message
//			ELSE OK message
void
Check_Balance(InvRec_T Rec) {

	if (Rec.Balance >= HighBalance) {
		cout	<< "At "
				<< Rec.Balance
				<< " account is too high\n";
	}
	else {
		cout	<< "Account is fine - it is less than "
				<< HighBalance
				<< "\n";
	}
}


// PRE	TRUE
// POST	prints out menu
void
Menu() {
	cout	<< "(r)ead new record\n"
			<< "(w)rite out current record\n"
			<< "(c)heck balance\n"
			<< "this (m)enu\n"
			<< "e(x)it\n";
}

void
Initialise() {
	char Dummy;

	cout	<< "This program will firstly prompt you for an invoice record\n"
			<< "containing\n"
			<< "	- an invoice number - e.g. 23987\n"
			<< "	- a balance - e.g. 165.43\n"
			<< "	- a department as an integer - e.g. 2 for Food\n"
			<< "and will then repeat prompting for options to"
			<< "	- read another record\n"
			<< "	- print the current record\n"
			<< "	- check the balance is not greater than the 2000.0 threshold\n"
			<< "**************************************************************"
			<< "\n\n\n\nPress ENTER to continue";
	cin.get(Dummy);
	cout	<<	"\nFirst type in the record as prompted"
			<< "\nthen you type 'm' for menu"
			<<	"\nand carry on from there\n\n";
}


void
Loop(InvRec_T &InvRec) {
	char Option;

	for (Option = 'r'; Option != 'x';) {
		switch (Option) {
			case 'm':
				Menu();
			break;
			case 'r':
				Read_Rec(InvRec);
			break;
			case 'w':
				Write_Rec(InvRec);
			break;
			case 'c':
				Check_Balance(InvRec);
			break;
			default:
				cout	<<	"\n\nOption not recognised\n\n";
				Menu();
			break;
		}
		cout	<< "\n\nPlease type in next option ===> ";
		cin	>> Option;
	}
}


void
Finalise() {
	cout << "End of the invoice program";
}


void
main() {
	InvRec_T InvRec;

	Initialise();
	Loop(InvRec);
	Finalise;
}

