// inv_arr.cpp
// 4/4/99
// Solution of simple array with records as elements
// Ken Brownsey


#include <iostream.h>
#include "my_const.h"

#define Max 5

typedef enum	Dept_T {Toys, Food, Clothing};

typedef int InvNum_T;

typedef float Balance_T;

typedef struct {
	InvNum_T		InvoiceNum;
	Balance_T	Balance;
	enum 	Dept_T Dept;
} InvRec_T;

typedef InvRec_T InvoiceArray_T[Max];

typedef struct {
	InvoiceArray_T	Invoices;
	int			NextVacancy;
} InvoiceTable_T;

InvoiceTable_T	Table;


// PRE	TRUE
// POST	Prompts user for department by number
//		and returns mode read in defaulting to Food */
enum Dept_T
Read_Dept() {
	int	InData;
	Dept_T Result;

	cout	<< "\nToys please enter 1 ";
	cout	<< "\nFood please enter 2 ";
	cout	<< "\nClothing please enter 3 ";
	cout	<< "\n ====>  ";
	cin	>> InData;
	switch (InData) {

		case 1:
			Result = Toys;
		break;
		case 2:
			Result = Food;
		break;
		case 3:
			Result = Clothing;
		break;
		default:
			Result = Food;
		break;
	}
	return(Result);
}


// PRE	Dept has a valid value
// POST	Prints string for Dept
void
Write_Dept(enum Dept_T Dept) {
	switch(Dept) {

		case Toys:
			cout << "\nToys and Games";
		break;
		case Food:
			cout	<< "\nFood and Drink";
		break;
		case Clothing:
			cout	<< "\nClothing and Bedding";
		break;
		default:
		break;
	}
}



//	PRE	TRUE
//	POST	prompts user for invoice record
//			which is read into InvRec
void
Read_Rec(InvRec_T &InvRec) {

	cout	<< "\nInvoice Number ==> ";
	cin	>> InvRec.InvoiceNum;
	cout	<< "\nBalance ==> ";
	cin	>> InvRec.Balance;
	cout	<< "\nDepartment ";
	InvRec.Dept = Read_Dept();
}



/*	PRE	TRUE */
/*	POST	writes Rec to screen */
void
Write_Rec(InvRec_T Rec) {

	cout	<< "\nInvoice Number is "
			<< Rec.InvoiceNum
			<< "\nBalance is "
			<< Rec.Balance
			<< "\nDept is ";
	Write_Dept(Rec.Dept);
	cout	<< "\n";
}



//	PRE Q_Full(Tab) is FALSE
// POST NewInvoice is added to Tab
void
Add_Invoice(InvRec_T NewInvoice, InvoiceTable_T &Tab) {
	Tab.Invoices[Tab.NextVacancy] = NewInvoice;
	Tab.NextVacancy++;
}


// PRE TRUE
// POST 	IF Tab is full RETURNS TRUE
//       ELSE RETURNS FALSE
BOOLEAN
Q_Full(InvoiceTable_T Tab) {
	return(Tab.NextVacancy == Max);
}


// PRE TRUE
// POST 	IF Tab is empty RETURNS TRUE
//       ELSE RETURNS FALSE
BOOLEAN
Q_Empty(InvoiceTable_T Tab) {
	return(Tab.NextVacancy == 0);
}

// PRE	TRUE
// POST	IF Invoice is in Table RETURNS TRUE
//			ELSE RETURNS FALSE
BOOLEAN
Q_Present(InvNum_T InvNum, InvoiceTable_T Table) {
	int Index;
	BOOLEAN Q_Found;

	Q_Found = FALSE;

	for (Index =0; (Index < Table.NextVacancy) && !Q_Found; Index++) {
		if (Table.Invoices[Index].InvoiceNum == InvNum) {
			Q_Found = TRUE;
		}
	}
	return(Q_Found);
}


// PRE	Invoice record with key value InvNum is in Tab
// POST  Invoice record is removed from Tab
void
Delete_Invoice(InvNum_T InvNum, InvoiceTable_T &Table) {
		int	Index;
	BOOLEAN Q_Found;

	Q_Found = FALSE;

	for (Index =0; !Q_Found; Index++) {
		if (Table.Invoices[Index].InvoiceNum == InvNum) {
			Q_Found = TRUE;
		}
	}
	/* Index is now one past where we want to delete so..*/
	Index--;

	Table.NextVacancy--;

	for (; Index < Table.NextVacancy; Index++) {
		Table.Invoices[Index] = Table.Invoices[Index + 1];
	}

}


// PRE TRUE
// POST	IF Q_Full(Tab) appropriate message is printed
//			ELSE user is prompted for number to be added to Tab
void
Read_NewInvoice(InvoiceTable_T &Tab) {
	InvRec_T	NewInvoice;

	if (Q_Full(Tab)) {
		cout 	<< "Sorry - table is now full\n";
		cout 	<< "You need to delete some to put new records in \n";
	}
	else {
		cout	<< "Please type in a new record to be added ==> ";
		Read_Rec(NewInvoice);
		Add_Invoice(NewInvoice, Tab);
	}
}


// PRE TRUE
// POST 	prompts user for value
//			IF value is in Tab prints out message to say so
//       ELSE prints out message to show it is not there
void
Check_Invoice(InvoiceTable_T Tab) {
	InvNum_T	InvNum;

	if (!Q_Empty(Tab)){
		cout 	<< "Please type in number of invoice record to check ==> ";
		cin	>> InvNum;

		if (Q_Present(InvNum, Tab)) {
			cout	<< "Invoice record with number "
					<<	InvNum
					<< " is in the table\n";
		}
		else {
			cout	<< "There is no invoice record with number "
					<<	InvNum
					<<	" in the table\n";
		}
	}
	else {
		cout	<< ("\nTable is empty - nothing to check\n");
	}
}


// PRE	TRUE
// POST  prompts user for value
//			IF value is in table it is removed and
//				message to show success
//			ELSE message to say that it is not present
void
Remove_Invoice(InvoiceTable_T &Tab) {

	InvNum_T	InvNum;

	if (!Q_Empty(Tab)){
		cout 	<< "Please type in the key value of a invoice record to delete ==> ";
		cin	>> InvNum;

		if (Q_Present(InvNum, Tab)) {
			Delete_Invoice(InvNum, Table);
			cout	<< "Invoice record with key "
					<<	InvNum
					<<	" has been deleted from the table\n";
		}
		else {
			cout	<< "Invoice record with key "
					<<	InvNum
					<< " is not in the table to begin with\n";
		}
	}
	else {
		cout	<< ("\nTable is empty - nothing to delete\n");
	}
}


//	PRE	TRUE
//	POST	IF Tab is not empty all values are printed to screen
//			ELSE message to say that Tab is empty
void
Print_All(InvoiceTable_T Tab) {

	int	Index;

	if (!Q_Empty(Tab)) {
		cout	<< "\n******************\nContents of the table are as follows\n\n";
		for (Index = 0; Index < Tab.NextVacancy; Index++) {
			cout	<< "Record in position "
					<< (Index + 1)
					<< " is as follows ";
			Write_Rec(Tab.Invoices[Index]);
			cout	<< "\n";
		}
		cout	<< ("\n******************\nThat's all!\n");
	}
	else {
		cout	<< ("\nTable is empty - nothing to print\n\n");
	}
}



//	PRE TRUE
//	POST menu is displayed
void
Menu() {
	cout 	<< "show (m)enu\n";
	cout 	<< "(r)ead in new value\n";
	cout 	<< "(c)heck value is in table\n";
	cout 	<< "r(e)move value from table\n";
	cout 	<< "(p)rint all values in table\n";
	cout  << "e(x)it\n";
}


void
Initialise(InvoiceTable_T &Tab) {
	cout	<< "*********************************\n";
	cout	<< "The great invoice storage program\n";
	cout	<< "*********************************";
	Tab.NextVacancy = 0;
}


void
Loop(InvoiceTable_T &Tab) {
	char	Option;


	for(Option = 'm'; Option != 'x';) {
		switch (Option) {
			case 'm':
				Menu();
			break;
			case 'r':
				Read_NewInvoice(Tab);
			break;
			case 'c':
				Check_Invoice(Tab);
			break;
			case 'e':
				Remove_Invoice(Tab);
			break;
			case 'p':
				Print_All(Tab);
			break;
			default:
				Menu();
			break;
		}
		cout 	<< "\nPlease type next option ==> ";
		cin   >> Option;
	}
}


void
Finalise(InvoiceTable_T Tab) {
	cout	<< "*********************************\n";
	cout	<< "That's it folks..................\n";
	cout	<< "*********************************";
}


void
main() {
	Initialise(Table);
	Loop(Table);
	Finalise(Table);
}



