// searchdb.cpp
// 6/7/99
// Demo of searching ordered array
// Ken Brownsey


#include <iostream.h>
#include "sortdb.h"
#include <stdlib.h>



//	PRE	Size > 0
//	POST	IF Value present in elements [0..TopLimit] of DB
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE

BOOLEAN
Q_Present(int	Value, SortArray_T DB, int TopLimit) {
	int Index;

	for(Index = 0; Index <= TopLimit; Index++) {
		if (Value == DB[Index]) {
			return(TRUE);
		}
	}
	return(FALSE);
}

//	PRE	Size > 0
//	POST	Elements [0..Size - 1] of DB
//			populated with values 1<=Val<=MaxVal
void
Make_RandomArray(SortArray_T &DB, int Size, int MaxVal) {
	int	Index;
	int	NextVal;

	if (DB != NULL) {
		delete [] DB;
	}
	DB = new int[Size];
	DB[0] = 1 + rand() % MaxVal;
	for(Index = 1; Index < Size; Index++) {
		NextVal = 1 + rand() % MaxVal;
		for(;Q_Present(NextVal, DB, Index - 1);) {
			NextVal = 1 + rand() % MaxVal;
		}
		DB[Index] = NextVal;
	}
}


//	PRE	Num > 0
int
Find_NumDigits(int Num) {
	int	Index;

	for(Index = 0; Num > 0; Index++) {
		Num = Num / 10;
	}
	return(Index);
}


//	PRE	Hi >= Lo
//	POST	All values in positions [Lo..Hi]
//			are printed to screen
void
Print_Array_Interval(SortArray_T DB, int Lo, int Hi) {
	#define FieldWidth 3
	int	Index;
	int	SpaceIndex;

	for(Index = 0; Index <= Hi; Index++) {
		if (Index < Lo) {
			//Do nothing replaces padding spaces for bubble sort demonstration
		}
		else {
			for (SpaceIndex = 1; SpaceIndex <= FieldWidth - Find_NumDigits(DB[Index]); SpaceIndex++) {
				cout	<<	" ";
			}
			cout	<<	DB[Index];
		}
	}
}










