// sequence.h
// 1/8/98
// Sequence_T implementation based on array
// Ken Brownsey


#include "my_const.h"

typedef void *Sequence_T;
typedef int	Key_T;
typedef Key_T	Element_T;

// PRE	TRUE
// POST	RETURNS an initialised Sequence_T
Sequence_T
Create_Sequence();


// PRE	TRUE
//	POST	IF Sequence is full THEN
//				RETURNS TRUE
//			ELSE RETURNS FALSE
BOOLEAN
Q_Full(Sequence_T Sequence);


// PRE	TRUE
//	POST	IF Sequence is empty THEN RETURNS TRUE
//			ELSE RETURNS FALSE
BOOLEAN
Q_Empty(Sequence_T Sequence);


// PRE	NOT Q_Empty(Sequence)
//	POST	IF current element last in Sequence THEN
//				RETURNS TRUE
//			ELSE RETURNS FALSE
BOOLEAN
Q_At_End(Sequence_T Sequence);


// PRE	NOT Q_Empty(Sequence)
//	POST	first element of Sequence' is the current element
void
Go_To_Head(Sequence_T Sequence);


// PRE	NOT Q_Empty(Sequence) AND
//			NOT Q_At_End(Sequence)
//	POST	current element in Sequence' is the one after
//			current element in Sequence
void
Go_To_Next(Sequence_T Sequence);


// PRE	NOT Q_Empty(Sequence)
// POST	RETURNS current record
Element_T
Get_Current(Sequence_T Sequence);


// PRE	TRUE
// POST	Sequence' = Sequence with Element added AND
//			IF Q_Empty(Sequence) THEN
//				current of Sequence' is first element
//			ELSE
//				Element is after current in Sequence'
void
Append_After_Current(Element_T Element, Sequence_T Sequence);


// PRE	NOT Q_Empty(Sequence)
// POST	Sequence' = Sequence with Element added AND
//			Element is before current in Sequence'
void
Insert_Before_Current(Element_T Element, Sequence_T Sequence);


// PRE	NOT Q_Empty(Sequence)
// POST	Sequence' = Sequence with current of Sequence removed AND
//			IF NOT(Q_Empty(Sequence'))
//				current of Sequence' is first element of Sequence'
void
Delete_Current(Sequence_T Sequence);

//	PRE	Q_Empty(Sequence)
//	POST	all memory allocated to Sequence is freed up
// NOTES	Sequence will need to be re-initialised
//			with Create_Sequence() before being used again
void
Free_Sequence(Sequence_T Sequence);

