// hashtab.h
// 6/7/99
//	Hash table demonstration
// Ken Brownsey

#include "my_const.h"
#include "sequence.h"

typedef void *HashTable_T;


//	PRE	NumLocations > 0
// POST	HashTable' contains NumLocations
//			buckets
//			AND Q_EmptyHashTable(HashTable')
void
Create_HashTable(HashTable_T &HashTable, int NumLocations);


//	PRE
//	POST	IF HashTable is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyHashTable(HashTable_T HashTable);


//	PRE	TRUE
// POST	HashTable' = HashTable with NewRec added
void
Add_Value(int Value, HashTable_T HashTable);


//	PRE	TRUE
// POST	IF Value is in HashTable
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_PresentValue(int Value, HashTable_T HashTable);


//	PRE	TRUE
//	POST 	Q_EmptyHashTable(HashTable)
void
Make_Empty(HashTable_T HashTable);


//	PRE	TRUE
//	POST	All memory allocted to HashTable is freed up
void
Delete_HashTable(HashTable_T &HashTable);


//	PRE	TRUE
//	POST	Prints out contents of HashTable bucket by bucket
void
Print_HashTable(HashTable_T &HashTable);

