//sortdemo.cpp
// 6/7/99
//	Demo of QuickSort
// Ken Brownsey

#include <iostream.h>
#include "sortdb.h"
#include <stdlib.h>

typedef enum {NoStop, StopAndDisplay, ShowEverySwap} DemoMode_T;

SortArray_T	DataBase = NULL;
int			DBSize = 0;


//	PRE	Size > 0
//	POST	all values in DB
//			are printed to screen
void
Print_All_Values(SortArray_T DB, int Size) {

	if (Size > 0) {
		cout	<< "\n******************\nValues of the table are as follows\n\n";
		Print_Array_Interval(DB, 0, Size - 1, -1);
		cout	<< ("\n******************\nThat's all the values!\n");
	}
	else {
		cout	<< ("\nDatabase is empty - no keys to print\n\n");
	}
}


//	PRE	TRUE
//	POST	User is prompted for Size of OrdDB
//			if Size > 0
//				OrdDB contains Size elements unordered
//			else
//				message
void
Build_UnOrdered_RandomDB(SortArray_T &UnOrdRandDB, int &Size) {

	cout	<< "\nPlease type in number of elements ==> ";
	cin	>>	Size;
	if (Size > 0 ) {
		Make_UnOrdered_RandomArray(UnOrdRandDB, Size, 2 * Size);
	}
	else {
		cout	<<	"\n"
				<<	Size
				<<	" is less than 0";
	}
}


//	PRE	TRUE
//	POST	User is prompted for Size of OrdDB
//			if Size > 0
//				OrdDB contains Size elements in order
//			else
//				message
void
Build_Ordered_RandomDB(SortArray_T &OrdRandDB, int &Size) {

	cout	<< "\nPlease type in number of elements ==> ";
	cin	>>	Size;
	if (Size > 0 ) {
		Make_Ordered_RandomArray(OrdRandDB, Size, 2 * Size);
	}
	else {
		cout	<<	"\n"
				<<	Size
				<<	" is less than 0";
	}
}


//	PRE	TRUE
//	POST	User is prompted for Size of OrdDB
//			if Size > 0
//				OrdDB contains Size elements in REVERSE order
//			else
//				message
void
Build_ReverseOrdered_RandomDB(SortArray_T &OrdRandDB, int &Size) {

	cout	<< "\nPlease type in number of elements ==> ";
	cin	>>	Size;
	if (Size > 0 ) {
		Make_ReverseOrdered_RandomArray(OrdRandDB, Size, 2 * Size);
	}
	else {
		cout	<<	"\n"
				<<	Size
				<<	" is less than 0";
	}
}


//	PRE	Lo < Hi AND Array[Lo] = Pivot
//	POST	Elements of Array' = elements of Array
//	AND	Lo' = Lo
//	AND 	Hi' = Hi
//	AND	(Array'[Lo..LastLessThanPivot] < Pivot
//	AND	Array'[PivotIndex] = Pivot
//	AND	(Array'[PivotIndex+1..Hi] > Pivot
void
Partition(	SortArray_T Array,	int Lo, int Hi,
				int &PivotIndex, DemoMode_T Mode,
				float &Swaps, float &Comps, int DBSize) {
	int	Hold;
	int	NextToBePlaced;
	int	LastLessThanPivot;
	int	PivotValue;
	char	ContinueDummy;
	#define NoPrint -1
	//	INVARIANT
	// Array[1..LessThanPivot] < Pivot AND
	// Array[LessThanPivot + 1..NextToBePlaced-1] >= Pivot

	PivotValue = Array[Lo];
	if ((Mode == StopAndDisplay)||(Mode == ShowEverySwap)) {
		 cout	<<	"Lo is "
				<<	Lo
				<<	"  -  Hi is "
				<<	Hi
				<<	"\n";
		Print_HighLightedArray(Array, Lo, Hi, NoPrint, ' ', DBSize);
		cout	<<	"\n";
	}

	LastLessThanPivot = Lo;
	NextToBePlaced = Lo + 1;
	for (;NextToBePlaced <= Hi;) {
		if (Array[NextToBePlaced] < PivotValue) {
			Hold = Array[NextToBePlaced];
			Array[NextToBePlaced] = Array[LastLessThanPivot + 1];
			Array[LastLessThanPivot + 1] = Hold;
			LastLessThanPivot++;
			if (Mode == ShowEverySwap) {
				Print_HighLightedArray(Array, Lo, Hi, LastLessThanPivot, 'A', DBSize);
				cout	<<	"\n";
			}
			Swaps++;;
		}
		Comps++;
		NextToBePlaced++;
	}
	Hold = Array[Lo];
	Array[Lo] = Array[LastLessThanPivot];
	Array[LastLessThanPivot] = Hold;
	if (Mode == ShowEverySwap) {
		Print_HighLightedArray(Array, Lo, Hi, LastLessThanPivot, 'A', DBSize);
		cout	<<	"\n";
	}
	Swaps++;
	PivotIndex = LastLessThanPivot;

	if ((Mode == StopAndDisplay)||(Mode == ShowEverySwap)) {
		Print_HighLightedArray(Array, NoPrint, NoPrint, PivotIndex, 'P', DBSize);
		cout	<<	"\n******************* press key to continue\n";
		cin.get(ContinueDummy);
	}
}



void
QuickSort_R(SortArray_T Array, int Lo, int Hi, DemoMode_T Mode,
				int &Calls, float &Swaps, float &Comps, int DBSize) {
	int	PivotIndex;

	Calls++;
	if (Lo < Hi) {
		Partition(Array, Lo, Hi, PivotIndex, Mode, Swaps, Comps, DBSize);
		QuickSort_R(Array, Lo, PivotIndex - 1, Mode, Calls, Swaps, Comps, DBSize);
		QuickSort_R(Array, PivotIndex + 1, Hi, Mode, Calls, Swaps, Comps, DBSize);
	}
}


//void
//QSort() {
//	char Opt;


//	PRE	TRUE
//	POST	Array' is QuickSorted
void
Do_QuickSort(SortArray_T Array, int Size) {
	int	Calls;
	float	Swaps;
	float	Comps;
	DemoMode_T	Mode;
	char	Response;

	cout	<<	"\nDo you want the array displayed after every partition ?";
	cin	>>	Response;
	if (Response != 'y') {
		Mode = NoStop;
	}
	else {
		cout	<<	"\nDo you want the array displayed after every partition ?";
		cin	>>	Response;
		if (Response != 'y') {
			Mode = StopAndDisplay;
		}
		else {
			Mode = ShowEverySwap;
		}
	}
	if	(Size > 0) {
		Calls = 0;
		Swaps = 0;
		Comps = 0;
		QuickSort_R(Array, 0, Size - 1, Mode, Calls, Swaps, Comps, Size);
		cout	<<	"\nThis QuickSort took "
				<<	Calls
				<<	" recursive calls "
				<<	"\nand "
				<<	Comps
				<<	" comparisons "
				<<	"\nand "
				<<	Swaps
				<<	" swaps on an array of size "
				<< Size
				<<	"\n";
	}
	else {
		cout	<< "\nSize must be greater than 0 - no QuickSort to do !";
	}
}




//	PRE	TRUE
//	POST	User is prompted for
//			number of sorts NumSorts
//			if NumSorts > 0
//				MaxVal sorts are done on DB
//				AND results displayed
//			else
//				message
void
Do_Multiple_Random_Sorts(SortArray_T Array, int &Size) {
	float	NumSorts;
	float	Index;
	int	Calls;
	float	Swaps;
	float	Comps;
	float	NumCalls;
	float	NumComps;
	float	NumSwaps;

	cout	<< "\nPlease type in number of elements ==> ";
	cin	>>	Size;
	if (Size > 0 ) {
		cout	<<	"\nPlease input number of searches to be done ==> ";
		cin	>> NumSorts;
		if (NumSorts > 0) {
			NumCalls = 0;
			NumSwaps = 0;
			NumComps = 0;
			for(Index = 1; Index <= NumSorts; Index++) {
				Calls = 0;
				Swaps = 0;
				Comps = 0;
				Make_UnOrdered_RandomArray(Array, Size, 2 * Size);
				QuickSort_R(Array, 0, Size - 1, NoStop, Calls, Swaps, Comps, Size);
				NumCalls = NumCalls + Calls;
				NumComps = NumComps + Comps;
				NumSwaps = NumSwaps + Swaps;
			}

			cout	<<	"\nThere were "
					<<	NumCalls
					<<	" calls"
					<<	"\nAverage of  "
					<<	NumCalls/NumSorts
					<<	" calls per sort"
					<<	"\nThere were "
					<<	NumComps
					<<	" comparisons"
					<<	"\nAverage of  "
					<<	NumComps/NumSorts
					<<	" comparisons per sort"
					<<	"\nThere were "
					<<	NumSwaps
					<<	" swaps"
					<<	"\nAverage of  "
					<<	NumSwaps/NumSorts
					<<	" swaps per sort";
		}
		else {
			cout	<< "\n"
					<<	NumSorts
					<<	" less than zero";
		}
	}
	else {
		cout	<<	"\n"
				<<	Size
				<<	" is less than 0";
	}
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<< "***	(p)rint all values        ****************\n"
			<< "***	build (u)nordered random database        ***\n"
			<< "***	build (o)rdered random database        ***\n"
			<< "***	build (r)everseordered random database  **\n"
			<< "***	do multiple random (s)earches of database \n"
			<< "***	(q)uick sort database ********************\n"
			<< "***   e(x)it					      ***************\n"
			<< "***   (m)enu						   ***************\n";
}


// PRE	TRUE
// POST	Sets up
void
Initialise(int	&DBSize) {

	DBSize = 0;
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(SortArray_T DB) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'p' :	Print_All_Values(DB, DBSize);
				break;
			case 'u' :	Build_UnOrdered_RandomDB(DB, DBSize);
				break;
			case 'o' :	Build_Ordered_RandomDB(DB, DBSize);
				break;
			case 'r' :	Build_ReverseOrdered_RandomDB(DB, DBSize);
				break;
			case 'q' :	Do_QuickSort(DB, DBSize);
				break;
			case 's' :	Do_Multiple_Random_Sorts(DB, DBSize);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(SortArray_T DB) {
	cout	<< "That is it !\n";
}


void
main() {
	Initialise(DBSize);
	Loop(DataBase);
	Finalise(DataBase);
}
