// sortdb.h
// 6/7/99
// Radix sort set up
// Ken Brownsey


#include "my_const.h"
#include "sequence.h"

typedef Sequence_T SortDB_T;


//	PRE	Q_Full(DB) is FALSE
//       AND keys in DB are in order
// POST	DB' = DB with NewRec added
//       AND keys in DB' are in order
void
Add_Value(int Value, SortDB_T DB);


// PRE	DB is in ascending key order
// POST	IF Value is in DB
//				Position is position in DB
//				RETURNS TRUE
//			ELSE
//				IF at least one value in DB > Value
//					Position is that of the
//					next largest to Value
//				ELSE
//					Position is that of last in DB
//				RETURNS FALSE
BOOLEAN
Q_PresentOrd(int Value, SortDB_T DB, int &Position);


// PRE	TRUE
// POST	IF Value is in DB
//				Position is position in DB
//				RETURNS TRUE
//			ELSE
//				Position is that of last in DB
//				RETURNS FALSE
BOOLEAN
Q_PresentUnOrd(int Value, SortDB_T DB, int &Position);


//	PRE	Size > 0
// POST	OrdRandDB contains Size distinct
//			integers in the range 1..2 * Size
//			in ascending order
void
Make_Ordered_RandomDB(SortDB_T OrdRandDB, int Size);


//	PRE	Size > 0
// POST	UnOrdRandDB contains Size distinct
//			integers in the range 1..2 * Size
//			in random order
void
Make_UnOrdered_RandomDB(SortDB_T UnOrdRandDB, int Size);


//	PRE	TRUE
//	POST 	Q_Empty(DB)
void
Make_Empty(SortDB_T DB);
