// srchdemo.cpp
// 6/7/99
// Demo of searching ordered and unordered sequence
// Ken Brownsey

#include <iostream.h>
#include "searchdb.h"
#include <stdlib.h>

// PRE 	DB is in ascending key order
// POST 	prompts user for key value
//			IF key value is in DB
//				prints out message to say so
//				AND prints out value of record
//				AND key of current record in DB'
//              is key value
//       ELSE prints out
//				message to show it is not there
void
Check_ValueOrd(SearchDB_T DB) {
	int 	Value;
	int	Position;

	if (!Q_Empty(DB)){
		cout 	<< "Please type in key of student record to check ==> ";
		cin	>> Value;

		if (Q_PresentOrd(Value, DB, Position)) {
			cout	<< "Value  "
					<<	Value
					<< " is in the table at position "
					<<	Position
					<<	"\nRecord is ";
					Write_Rec(Get_DataRec(Get_Current(DB)));
		}
		else {
			cout	<< "There is no student record with key "
					<<	Value
					<< " in the table\n"
					<< "Search stopped at position "
					<<	Position
					<<	"\n";
		}
	}
	else {
		cout	<< ("\nDB is empty - nothing to check\n");
	}
}


//	PRE	TRUE
//	POST  Q_At_End(DB')
//			IF DB is not empty
//				all values are printed to screen
//			ELSE
//				message to say that DB is empty
void
Print_All_Values(SearchDB_T DB) {

	if (!Q_Empty(DB)) {
		cout	<< "\n******************\nValues of the table are as follows\n\n";
		Go_To_Head(DB);
		for(;!Q_At_End(DB);) {
			Write_Rec(Get_DataRec(Get_Current(DB)));
			Go_To_Next(DB);
			cout	<< "\n";
		}
		Write_Rec(Get_DataRec(Get_Current(DB)));
		cout	<< ("\n******************\nThat's all the values!\n");
	}
	else {
		cout	<< ("\nDatabase is empty - no keys to print\n\n");
	}
}


//	PRE	TRUE
//	POST  Q_At_End(DB')
//			RETURNS Size of DB
int
Get_Size(SearchDB_T DB) {
	int	Size;

	Size = 0;
	if (!Q_Empty(DB)) {
		Go_To_Head(DB);
		for(;!Q_At_End(DB);) {
			Size++;
			Go_To_Next(DB);
		}
		Size++;
	}
	return(Size);
}


void
Do_Multiple_Random_Searches(SearchDB_T SearchDB) {
	int	MaxVal;
	float	NumSearches;
	float	Index;
	int	Target;
	int	Position;
	float	NumComps;
	float	NumHits;

	cout	<<	"\nPlease input maximum value to be searched for ==> ";
	cin	>> MaxVal;
	if (MaxVal >0) {
		cout	<<	"\nPlease input number of searches to be done ==> ";
		cin	>> NumSearches;
		if (NumSearches > 0) {
			NumComps = 0;
			NumHits = 0;
			for(Index = 1; Index <= NumSearches; Index++) {
				Target = 1 + rand() % MaxVal;
				if (Q_PresentOrd(Target, SearchDB, Position)) {
					NumHits++;
				}
				NumComps = NumComps + Position;
			}

			cout	<<	"\nSize of database is "
					<<	Get_Size(SearchDB)
					<<	"\nThere were "
					<<	NumComps
					<<	" comparisons"
					<<	"\nThere were "
					<<	NumHits
					<<	" hits"
					<<	"\nAverage of  "
					<<	NumComps/NumSearches;
			}
		}
	}



// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<< "***	(p)rint all values        ****************\n"
			<< "***	(c)heck key - ordered database      ******\n"
			<< "***	do multiple random (s)earches of database \n"
			<< "***	(l)oad database from file\n"
			<< "***	make database (e)mpty  *******************\n"
			<< "***   e(x)it					      ***************\n"
			<< "***   (m)enu						   ***************\n";
}


// PRE	TRUE
// POST	Clears up
void
Initialise(SearchDB_T *DB_Ptr) {

	(*DB_Ptr) = Create_Sequence();
	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(SearchDB_T DB) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'p' :	Print_All_Values(DB);
				break;
			case 'c' :	Check_ValueOrd(DB);
				break;
			case 's' :	Do_Multiple_Random_Searches(DB);
				break;
			case 'l': 	Load_DB_From_File(DB);
				break;
			case 'e' :	Make_Empty(DB);
				break;
			case 'm' : 	Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(SearchDB_T DB) {
	Make_Empty(DB);
	Free_Sequence(DB);
	cout	<< "That is it !\n";
}


void
main() {
	SearchDB_T	DataBase;

	Initialise(&DataBase);
	Loop(DataBase);
	Finalise(DataBase);
}
