// ArcData.h
// 14/5/99
// Ken Brownsey
//	arc records for Graph_T
#ifndef	ARCDATA_H
#define 	ARCDATA_H

#include <fstream.h>
#include "my_const.h"
#include "vstore.h"

typedef int	ArcKey_T;

typedef struct {
	ArcKey_T	Number;
	char	*Name;
	VertKey_T	InitialVertKey,
					FinalVertKey;
	int	Weight;
} ArcDataRec_T;

// PRE	TRUE
// POST	user is prompted for arc key value which is returned
ArcKey_T
Read_ArcKey();


// PRE	TRUE
// POST	key value is written to screen
void
Write_ArcKey(ArcKey_T ArcKey);


// PRE	TRUE
// POST	returnS key value of ArcDataRec
ArcKey_T
Get_ArcKey(ArcDataRec_T ArcDataRec);


// PRE	TRUE
// POST	Returns name of ArcDataRec
char
*Get_ArcName(ArcDataRec_T ArcDataRec);


// PRE	TRUE
// POST	returnS key value of source vertex in ArcDataRec
VertKey_T
Get_InitialVertKey(ArcDataRec_T ArcDataRec);


// PRE	TRUE
// POST	returnS key value of sink vertex in ArcDataRec
VertKey_T
Get_FinalVertKey(ArcDataRec_T ArcDataRec);


// PRE	TRUE
// POST	returnS weight in ArcRec
VertKey_T
Get_Weight(ArcDataRec_T ArcDataRec);


//	PRE	TRUE
//	POST	prompts user for arc details
//			which are read into ArcDataRec
void
Read_ArcDataRec(ArcDataRec_T &ArcDataRec);


//	PRE	TRUE
//	POST	writes ArcDataRec to screen
void
Write_ArcDataRec(ArcDataRec_T ArcDataRec);


// PRE	FileHandle is a correctly opened stream
// POST	IF record read from file OK THEN
//				returnS record read
//				Q_ValidRecFromFile' = TRUE
//			ELSE
//				Q_ValidRecFromFile' = FALSE
ArcDataRec_T
Read_ArcDataRec_From_File(ifstream &InFile, BOOLEAN &Q_ValidRecFromFile);



// PRE	FileHandle is a correctly opened stream
// POST	ArcDataRec written to FileHandle stream
void
Write_ArcDataRec_To_File (ArcDataRec_T ArcDataRec, ofstream &OutFile);

#endif
