// AStore.cpp
// 14/5/99
// Stores vertex records and references them by key address pair records
// Ken Brownsey

#include "AStore.h"
#include <stdlib.h>
#include <string.h>

// PRE	TRUE
// POST	RETURNS a key adddress pair record with key that of record and
//			address that of location where record is stored
ArcKAPRec_T
MakeArcKAPRec(ArcDataRec_T Rec) {
	ArcKAPRec_T ArcKAPRec;
	ArcDataRec_T *Address;
	Address = new ArcDataRec_T;

	(*Address) = Rec;
	ArcKAPRec.ArcKey = Get_ArcKey(Rec);
	ArcKAPRec.InitialVertKey = Get_InitialVertKey(Rec);
	ArcKAPRec.FinalVertKey = Get_FinalVertKey(Rec);
	ArcKAPRec.Weight = Get_Weight(Rec);
	ArcKAPRec.Address = Address;
	return(ArcKAPRec);
}


// PRE	TRUE
// POST	RETURNS key value of ArcKAPRec
ArcKey_T
Get_ArcKAPRecKey(ArcKAPRec_T ArcKAPRec) {

	return(ArcKAPRec.ArcKey);
}


// PRE	TRUE
// POST	RETURNS from vertex key value of ArcKAPRec
VertKey_T
Get_ArcKAPRecInitialKey(ArcKAPRec_T ArcKAPRec) {

	return(ArcKAPRec.InitialVertKey);
}


// PRE	TRUE
// POST	RETURNS to vertex key value of ArcKAPRec
VertKey_T
Get_ArcKAPRecFinalKey(ArcKAPRec_T ArcKAPRec)  {

	return(ArcKAPRec.FinalVertKey);
}


// PRE	TRUE
// POST	RETURNS weight of ArcKAPRec
VertKey_T
Get_ArcKAPRecWeight(ArcKAPRec_T ArcKAPRec) {

	return(ArcKAPRec.Weight);
}





// PRE	TRUE
// POST	RETURNS record stored at address value of ArcKAPRec
ArcDataRec_T
Get_ArcDataRec(ArcKAPRec_T ArcKAPRec) {

	return(*(ArcKAPRec.Address));
}


// PRE	TRUE
// POST	Memory taken up by record referenced
//			by address attribute is freed up
void
Free_ArcKAPRecMemory(ArcKAPRec_T ArcKAPRec) {

	delete(ArcKAPRec.Address);
}



