// stack.h
// 7/8/98
// pointer based Stack_T with void * elements for tree traversal
// Ken Brownsey

#include "my_const.h"

typedef void *SElement_T;
typedef void *Stack_T;

// PRE	TRUE
// POST	RETURNS an initialised Stack_T
Stack_T
Create_Stack();


// PRE	NOT Q_FullStack(Stack)
// POST 	elements of Stack' = elements of Stack union {Element}
void
Push(SElement_T NewElement, Stack_T Stack);


// PRE	TRUE
// POST	IF Stack is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyStack(Stack_T Stack);


// PRE	TRUE
// POST	IF Stack is full
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_FullStack(Stack_T Stack);


// PRE	NOT Q_EmptyStack(Stack)
// POST	Stack' is Stack with the most recently entered
//			element removed
void
Pop(Stack_T Stack);


// PRE	NOT Q_EmptyStack(Stack)
// POST	RETURNS the value of the most recently
//				entered element of Stack *)
SElement_T
Top(Stack_T Stack);



//	PRE	Q_EmptyStack(Stack)
//	POST	all memory allocated to Stack is freed up
// NOTES	Stack will need to be re-initialised
//			with Create_Stack() before being used again
void
Free_Stack(Stack_T Stack);
