// Ken Brownsey
// 31/8/98
// bst_tree.h
// BST_T



#include "NStore.h"

typedef DataRec_T Element_T;

typedef void  *BST_T;
typedef void *BST_Iterator_T;

// PRE	TRUE
// POST	RETURNS the empty tree
BST_T
Create_Tree();


// PRE	TRUE
// POST	IF Tree is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyTree(BST_T Tree);


// PRE	Tree is not empty
// POST	RETURNS the record in the root
Element_T
Get_Root(BST_T Tree);


// PRE	TRUE
// POST	IF Tree is not empty
//				RETURNS the left sub tree of Tree
//			ELSE
//				RETURNS the empty tree
BST_T
Get_Left(BST_T Tree);



// PRE	TRUE
// POST	IF Tree is not empty
//				RETURNS the right sub tree of Tree
//			ELSE
//				RETURNS the empty tree
BST_T
Get_Right(BST_T Tree);


// PRE	TRUE
// POST	RETURNS the tree whose head is Root and tail is Tree
BST_T
Make_Tree(BST_T Left, Element_T Element, BST_T Right);


// PRE  - 	TRUE
// POST - 	RETURNS the number of nodes allocated
Get_NumberNodes_Allocated();


// PRE	TRUE
// POST	IF Rec is in BST
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_BST_Present_R(Key_T Key, BST_T BST);

// PRE	NOT Q_BST_Present_R(Rec, BST)
// POST	RETURNS BST with Rec inserted
void
BST_Insert_R(Element_T Rec, BST_T &BST);


// PRE	Q_BST_Present_R(Key, BST)
// POST	returnS record with key value Key from BST
Element_T
BST_Retrieve_R(Key_T Key, BST_T BST);

// PRE	TRUE
// POST	if (Q_BST_Present(Rec, BST)
//				returnS BST with Rec deleted
//			ELSE
//				returnS BST
void
BST_Delete_R(Key_T Key, BST_T &BST);


// PRE	TRUE
// POST	Iterator is created
BST_Iterator_T
Create_Iterator();


// PRE	TRUE
// POST	IF Reset_Iteration(Iterator, BST) has been executed
//				correctly for some value BST
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
Q_Bound_To_BST(BST_Iterator_T Iterator);


// PRE	TRUE
// POST	IF iteration is at ordinally keyed first node
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_StartOfIteration(BST_Iterator_T Iterator);


// PRE	Q_Bound_To_BST(Iterator)
// POST	IF iteration is at ordinally keyed last node
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EndOfIteration(BST_Iterator_T Iterator);


// PRE	NOT Q_EmptyTree(BST)
// POST	Iterator is reset with
//			ordinally first key node as current node
void
Reset_Iteration(BST_Iterator_T &Iterator, BST_T BST);

// PRE	Reset_Iteration(&Iterator, BST) has been called
//			for some value BST
//			AND NOT Q_EndOfIteration(Iterator)
// POST	NOT Q_Iteration_Reset(Iterator') AND
//					current is next node in iteration
void
Iterate(BST_Iterator_T &Iterator);


// PRE     Q_Iteration_Started(Iterator)
// RETURNS current record in iteration
Element_T
Get_Current(BST_Iterator_T Iterator);


// PRE	Q_Iteration_Started(Iterator)
// POST	RETURNS number of current record in iteration
int
Get_CurrentNumber(BST_Iterator_T Iterator);


// PRE	Create_Iterator(Iterator) has been called
//			AND since last, if any, call to
//			Destroy_Iterator(Iterator)
// POST	Iterator is destroyed
void
Destroy_Iterator(BST_Iterator_T Iterator);
