// graphdem.cpp
// 14/5/99
// Demonstrates Graph_T
// Ken Brownsey

#include "graph.h"
#include <iostream.h>

#define ReqSize	20


// Global list
Graph_T	Graph;
Traveller_T	Traveller;
BOOLEAN	Q_TravellerAssigned;

// PRE	TRUE
// POST	user is prompted for vertex
//			IF vertex is not in Graph
//				it is added to Graph
//			ELSE
//				appropriate message
void
Add_NewVertex(Graph_T &Graph) {

	VertDataRec_T	VertDataRec;

	cout	<< "\nType vertex in\n";
	Read_VertDataRec(VertDataRec);
	if (!Q_VertPresent(Get_VertKey(VertDataRec), Graph)) {
		Add_Vert(VertDataRec, Graph);
	}
	else {
		cout	<<	"\nVertex with key ";
		Write_VertKey(Get_VertKey(VertDataRec));
		cout	<< " is already in database\n";
	}
}


// PRE	TRUE
// POST	user is prompted for vertex
//			IF arc is in Graph
//				appropriate message
//			ELSE
//				IF from vertex not in Graph
//				appropriate message
//			ELSE
//				IF to vertex not in Graph
//				appropriate message
//			ELSE
//				it is added to Graph
void
Add_NewArc(Graph_T &Graph) {

	ArcDataRec_T	ArcDataRec;

	cout	<< "\nType arc in\n";
	Read_ArcDataRec(ArcDataRec);
	if (Q_ArcPresent(Get_ArcKey(ArcDataRec), Graph)) {
		cout	<<	"\nArc with key ";
		Write_ArcKey(Get_ArcKey(ArcDataRec));
		cout	<<	" is already in graph\n";
	}
	else {
		if (!Q_VertPresent(Get_InitialVertKey(ArcDataRec), Graph)) {
			cout	<<	"\nVertex with key ";
			Write_VertKey(Get_InitialVertKey(ArcDataRec));
			cout	<<	" is not in graph\n";
		}
		else {
			if (!Q_VertPresent(Get_FinalVertKey(ArcDataRec), Graph)) {
				cout	<<	"\nVertex with key ";
				Write_VertKey(Get_FinalVertKey(ArcDataRec));
				cout	<<	" is not in graph\n";
			}
			else {
				Add_Arc(ArcDataRec, Graph);
			}
		}
	}
}



// PRE	TRUE
// POST	user is prompted for key value
//			IF (vertex with that key is in Graph)
//				message to say so
//			ELSE
//				message to say not
void
Check_Vertex_Present(Graph_T Graph) {

	VertKey_T	Key;

	cout	<< "\nType key to be checked for ==> ";
	Key = Read_VertKey();
	if (Q_VertPresent(Key, Graph)) {
		cout	<<	"\nVertex key value ";
		Write_VertKey(Key);
		cout	<<	" is present in the database\n";
	}
	else {
		cout	<<	"\nVertex key value ";
		Write_VertKey(Key);
		cout	<<	" is not present in the database\n";
	}
}


// PRE	TRUE
// POST	IF  NOT Q_EmptyGraph(Graph)
//				user is prompted for key value
//				IF vertex with that key is in Graph
//					vertex is printed to screen
//				ELSE
//					message to say vertex not present
//			ELSE
//				message to say Graph is empty
void
Get_Vertex(Graph_T Graph) {
	VertKey_T	Key;
	
	if (!Q_EmptyGraph(Graph)) {
		cout	<< "\nType key of vertex to be retrieved ==> ";
		Key = Read_VertKey();
		if (Q_VertPresent(Key, Graph)) {
			cout	<<	"\nVertex is \n ";
			Write_VertDataRec(Get_VertDataRec(Retrieve_Vert(Key, Graph)));
			cout	<<	"\n";
		}
		else {
			cout	<<	"\nKey value ";
			Write_VertKey(Key);
			cout	<<	" is not present in the database\n";
		}
	}
	else {
		cout	<<	"\nDatabase is empty\n\n";
	}
}


// PRE	TRUE
// POST	if (Graph is not empty
//				it is printed in key order
void
Print_Vertices(Graph_T Graph) {
	char	Dummy;

	if (Q_EmptyGraph(Graph)) {
		cout	<< "\n No vertices to print \n";
	}
	else {
		Go_To_FirstVert(Graph);
		Write_VertDataRec(Get_VertDataRec(Get_CurrentVertKAPRec(Graph)));
		if (Q_Marked(Get_CurrentVertKAPRec(Graph))) {
			cout	<<	"\nMarked";
		}
		else  {
			cout	<<	"\nUnmarked";
		}
		for(;!Q_LastVert(Graph);) {
			cout	<<	"\nNext?\n";
			cin	>>	Dummy;
			Go_To_NextVert(Graph);
			Write_VertDataRec(Get_VertDataRec(Get_CurrentVertKAPRec(Graph)));
			if (Q_Marked(Get_CurrentVertKAPRec(Graph))) {
				cout	<<	"\nMarked";
			}
			else  {
				cout	<<	"\nUnmarked";
			}
		}
	}
}


// PRE	TRUE
// POST	IF NOT Q_EmptyGraph(Graph)
//				vertices of Graph' are set unmarked
void
UnMark_All(Graph_T Graph) {

	if (Q_EmptyGraph(Graph)) {
		cout	<< "\n No vertices to unmark \n";
	}
	else {
		Go_To_FirstVert(Graph);
		if (Q_Marked(Get_CurrentVertKAPRec(Graph))) {
			cout	<<	"\nMarked";
			UnSet_CurrentMark(Graph);
		}
		else  {
			cout	<<	"\nUnmarked";
		}
		for(;!Q_LastVert(Graph);) {
			Go_To_NextVert(Graph);
			if (Q_Marked(Get_CurrentVertKAPRec(Graph))) {
				cout	<<	"\nMarked";
				UnSet_CurrentMark(Graph);
			}
			else  {
				cout	<<	"\nUnmarked";
			}
		}
	}
}


// PRE	TRUE
// POST	if (Graph is not empty
//				it is printed in key order
void
Print_Arcs(Graph_T Graph) {
	char	Dummy;

	if (Q_NoArcs(Graph)) {
		cout	<< "\n No arcs to print \n";
	}
	else {
		Go_To_FirstArc(Graph);
		Write_ArcDataRec(Get_ArcDataRec(Get_CurrentArcKAPRec(Graph)));
		for(;!Q_LastArc(Graph);) {
			cout	<<	"\nNext?\n";
			cin	>>	Dummy;
			Go_To_NextArc(Graph);
			Write_ArcDataRec(Get_ArcDataRec(Get_CurrentArcKAPRec(Graph)));
		}
	}
}


// PRE	TRUE
// POST if (!Q_EmptyGraph) {
//			prints out size of tree
//		} else
//			empty tree message
void
Print_Size(Graph_T Graph) {
	if (!Q_EmptyGraph(Graph)) {
		cout	<< "\nSize is "
				<< Get_Size(Graph)
				<< "\n";
	}
	else {
		cout	<< "\Database is empty\n";
	}
}


// PRE	TRUE
// POST	IF NOT Q_EmptyGraph(Graph)
//				User is prompted for vertex key
//				IF key given is that of a vertex in the graph
//					Traveller' is at that vertex
//					AND Q_TravellerAssigned
//				ELSE
//					Appropriate message
//			ELSE
//		  		Appropriate message
void
Assign_Traveller_To_Vertex(Graph_T Graph, Traveller_T &Traveller, BOOLEAN &Q_TravellerAssigned) {

	VertKey_T VertKey;

	if (!Q_EmptyGraph(Graph)) {
		cout	<<	"\nPlease input key of vertex for traveller to start at ==> ";
		VertKey = Read_VertKey();
		if (Q_VertPresent(VertKey, Graph)) {
			if (!Q_TravellerAssigned) {
				Traveller = Create_Traveller(VertKey, Graph);
				Q_TravellerAssigned = TRUE;
			}
			else {
				Start_Traveller(Traveller, VertKey);
			}
		}
		else {
			cout	<<	"\nVertex with key ";
			Write_VertKey(VertKey);
			cout	<<	" is not in the graph";
		}
	}
	else {
		cout	<< "\nNo vertices in the graph";
	}
}


//	PRE	TRUE
//	POST	IF NOT Q_Dead_End(Traveller)
//				Prints out key of current arc for Traveller
//			ELSE
//				message
void
Print_CurrentNext_Arc(Traveller_T Traveller) {

	if (!Q_TravellerAssigned) {
		if (!Q_Dead_End(Traveller)) {
			cout	<<	" \nTraveller is looking at arc with key ";
			Write_ArcKey(Get_ArcKAPRecKey(Get_CurrentTraveller_ArcKAPRec(Traveller)));
		}
		else {
			cout	<<	"\nVertex  ";
			Write_VertKey(Get_TravellerVertKey(Traveller));
			cout	<< " is the end of a path";
		}
	}
}


//	PRE	TRUE
//	POST	IF NOT Q_Dead_End(Traveller)
//				IF NOT Q_No_More_Arcs(Traveller)
//					Current arc of Traveller' is one after current of Traveller
//				ELSE
//					message
//			ELSE
//				message
void
Move_To_Next_Arc(Traveller_T Traveller) {

	if (!Q_Dead_End(Traveller)) {
		if (!Q_No_More_Arcs(Traveller)) {
			Go_To_NextArc_From_Vertex(Traveller);
			cout	<<	"\nMoved to arc ";
			Write_ArcKey(Get_ArcKAPRecKey(Get_CurrentTraveller_ArcKAPRec(Traveller)));
			cout	<< " which goes to ";
			Write_VertKey(Get_ArcKAPRecFinalKey(Get_CurrentTraveller_ArcKAPRec(Traveller)));
		}
		else {
			cout	<<	"\nArc ";
			Write_ArcKey(Get_ArcKAPRecKey(Get_CurrentTraveller_ArcKAPRec(Traveller)));
			cout	<<	" is the last arc from vertex ";
			Write_VertKey(Get_TravellerVertKey(Traveller));
		}
	}
	else {
		cout	<<	"\nVertex  ";
		Write_VertKey(Get_TravellerVertKey(Traveller));
		cout	<< " is the end of a path";
	}
}


//	PRE	TRUE
//	POST	IF NOT Q_Dead_End(Traveller)
//				Current arc of Traveller' is one after current of Traveller
//			ELSE
//				message
void
Move_To_First_Arc(Traveller_T Traveller) {

	if (!Q_Dead_End(Traveller)) {
		Go_To_FirstArc_From_Vertex(Traveller);
		cout	<<	"\nMoved to first arc ";
		Write_ArcKey(Get_ArcKAPRecKey(Get_CurrentTraveller_ArcKAPRec(Traveller)));
		cout	<< " which goes to ";
		Write_VertKey(Get_ArcKAPRecFinalKey(Get_CurrentTraveller_ArcKAPRec(Traveller)));
	}
	else {
		cout	<<	"\nVertex  ";
		Write_VertKey(Get_TravellerVertKey(Traveller));
		cout	<< " is the end of a path";
	}
}


//	PRE	TRUE
//	POST	IF NOT Q_Dead_End(Traveller)
//				Traveller' is set to vertex at end of current arc of Traveller
//			ELSE
//				message
void
Move_Along_Current_Arc(Traveller_T Traveller) {

	if (!Q_Dead_End(Traveller)) {
		Move_To_Vertex_Along_Current_Arc(Traveller);
		cout	<<	"\nMoved to ";
		Write_VertKey(Get_TravellerVertKey(Traveller));
	}
	else {
		cout	<<	"\nVertex  ";
		Write_VertKey(Get_TravellerVertKey(Traveller));
		cout	<< " is the end of a path";
	}
}


//	PRE	TRUE
//	POST	prints out key of current vertex of Traveller
void
Print_Current_Vertex(Traveller_T Traveller) {

	cout	<<	"\nCurrent vertex is ";
	Write_VertKey(Get_TravellerVertKey(Traveller));
}


//	PRE	Q_Vert_For_Traveller(Traveller, VertKey)
//	POST	Prints out details of vertex with key VertKey
void
Print_VertexDetails(VertKey_T	VertKey, Traveller_T Traveller) {

	Write_VertKey(VertKey);
	cout	<< " called "
			<<	Get_VertName(Get_VertDataRec(Get_Vert_From_Traveller(Traveller, VertKey)));
}


//	PRE	NOT Q_EmptyGraph(Graph)
//			AND Q_VertPresent(ToVertKey, Graph)
//			AND Traveller is assigned to Graph
//	POST	IF there is a path from Get_TravllerVertKey(Traveller) to ToVertKey
//				this path is printed in reverse order
//				AND Q_OK' is TRUE
//			ELSE
//				Q_OK' is FALSE
void
Seek_R(VertKey_T StartVertKey, Traveller_T Traveller, VertKey_T EndVertKey, BOOLEAN &Q_PathFound) {
	char	Dummy;
	ArcKAPRec_T	NextArcKAPRec;
	BOOLEAN		Q_AllArcsTried;
	VertKey_T	FromVertKey;

	FromVertKey = Get_TravellerVertKey(Traveller);
	cout	<<	"\nENTERING Seek_R - press return";
	cin.get(Dummy);
	Set_TravellerMark(Traveller);
	if (FromVertKey == EndVertKey) {
		cout	<<	"\nEND OF PATH ";
		Print_VertexDetails(EndVertKey, Traveller);
		Q_PathFound = TRUE;
	}
	else {
		Q_PathFound = FALSE;
		if (!Q_Dead_End(Traveller)) {
			Q_AllArcsTried = FALSE;
			Go_To_FirstArc_From_Vertex(Traveller);
			for(;(!Q_PathFound) && (!Q_AllArcsTried);) {
				NextArcKAPRec = Get_CurrentTraveller_ArcKAPRec(Traveller);
				cout	<<	"\n ARC ";
				Write_ArcKey(Get_ArcKAPRecKey(NextArcKAPRec));
				cout	<< " called "
						<< Get_ArcName(Get_ArcDataRec(NextArcKAPRec))
						<< " to VERTEX ";
				Print_VertexDetails(Get_ArcKAPRecFinalKey(NextArcKAPRec), Traveller);
				if (!Q_VertMarked_For_Traveller(Get_ArcKAPRecFinalKey(NextArcKAPRec), Traveller)) {
					Move_To_Vertex_Along_Current_Arc(Traveller);
					Seek_R(StartVertKey, Traveller, EndVertKey, Q_PathFound);
					if (Q_PathFound) {
						if (StartVertKey != FromVertKey) {
							cout	<<	"\n   Path vertex  ";
						}
						else {
							cout	<<	"\nSTART vertex  ";
						}
						Print_VertexDetails(FromVertKey, Traveller);
					}
				}
				else {
					cout	<<	"\nNEXT VERTEX is ";
					Print_VertexDetails(Get_ArcKAPRecFinalKey(NextArcKAPRec), Traveller);
					cout	<< " and is marked ";
				}
				if (!Q_PathFound) {
					ReSet_Traveller(Traveller, FromVertKey, Get_ArcKAPRecKey(NextArcKAPRec));
					if (!Q_No_More_Arcs(Traveller)) {
						Go_To_NextArc_From_Vertex(Traveller);
					}
					else {
						if (FromVertKey != StartVertKey) {
							cout	<<	"\n   NOT Path vertex  ";
						}
						else {
							cout	<<	"\n   NO PATH AND BACK AT START ";
						}
						Print_VertexDetails(FromVertKey, Traveller);
						Q_AllArcsTried = TRUE;
					}
				}
			}
		}
		else {
			cout	<<	"\nNOT Path vertex DEAD END ";
			Print_VertexDetails(FromVertKey, Traveller);
		}
	}
}


//	PRE	NOT Q_EmptyGraph(Graph)
//			AND Q_VertPresent(InitialVertKey, Graph)
//			AND Q_VertPresent(ToVertKey, Graph)
//	POST	IF there is a path from FromVertKey to ToVertKey
//				this path is printed in reverse order
//				AND Q_OK' is TRUE
//			ELSE
//				Q_OK' is FALSE
void
Seek_Path(VertKey_T StartVertKey, VertKey_T EndVertKey, Graph_T Graph, BOOLEAN &Q_PathFound) {
	Traveller_T	Traveller;

	UnMark_All(Graph);
	Traveller = Create_Traveller(StartVertKey, Graph);
	Q_PathFound = FALSE;
	Seek_R(StartVertKey, Traveller, EndVertKey, Q_PathFound);
	if (Q_PathFound) {
		cout	<<	"\nPath found";
	}
	else {
		cout	<<	"\nPath not found";
	}
	Destroy_Traveller(Traveller);
}




//	PRE	NOT Q_EmptyGraph(Graph)
// POST	User is prompted for two vertex keys
//			IF both keys are in Graph
//				IF keys are different
//					IF there is a path between them
//						Path is printed
//					ELSE
//						Message no path
//				ELSE
//					Message same values of keys
//			ELSE
//				Messsage one or both keys not in Graph
void
Check_Path(Graph_T Graph) {
	VertKey_T	StartVertKey,
					EndVertKey;
	BOOLEAN		Q_PathFound;

	cout	<<	"\nPlease input the Start vertex key ==> ";
	cin	>>	StartVertKey;
	if (!Q_VertPresent(StartVertKey, Graph)) {
		cout	<<	"\nVertex with key ";
		Write_VertKey(StartVertKey);
		cout	<<	" is not in the graph";
		return;
	}
	cout	<<	"\nPlease input the End vertex key ==> ";
	EndVertKey =Read_VertKey();
	if (!Q_VertPresent(EndVertKey, Graph)) {
		cout	<<	"\nVertex with key ";
		Write_VertKey(EndVertKey);
		cout	<<	" is not in the graph";
		return;
	}
	if (StartVertKey == EndVertKey) {
		cout	<<	"\nBoth vertices have same value of ";
		Write_VertKey(StartVertKey);
		return;
	}
	Seek_Path(StartVertKey, EndVertKey, Graph, Q_PathFound);
}


// PRE	TRUE
// POST	menu displayed
void
Traveller_Menu() {

	cout	<< "***   Traveller Menu              ***********\n";
	cout	<< "***   assign (t)raveller ********************\n";
	cout	<< "***   print current (a)rc *******************\n";
	cout	<< "***   move to (f)irst arc *******************\n";
	cout	<< "***   move to (n)ext arc ********************\n";
	cout	<< "***   m(o)ve along current arc **************\n";
	cout	<< "***   (p)rint current vertex ****************\n";
	cout	<< "***   c(h)eck path **************************\n";
	cout	<< "***   this (m)enu	       	****************\n";
	cout	<< "***   e(x)it			        	****************\n";
}


// PRE	NOT Q_EmptyGraph(Graph)
// POST	Traveller initialised after interaction with user
void
Traveller_Initialise(Graph_T &Graph, Traveller_T	&Traveller, BOOLEAN	&Q_TravellerAssigned) {
	BOOLEAN	Q_KeepTrying;
	char	Response;

	Q_KeepTrying = TRUE;

	cout	<<	"\nEntering traveller options\n";

	for (;(Q_KeepTrying) && (!Q_TravellerAssigned);) {
		Assign_Traveller_To_Vertex(Graph, Traveller, Q_TravellerAssigned);
		if (!Q_TravellerAssigned) {
			cout	<<	"\nDo you want to try and assign traveller again (y/n) ==> ";
			cin	>> Response;
			Q_KeepTrying = (Response != 'n');
		}
	}
}


// PRE	NOT Q_EmptyGraph(Graph)
// POST	Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Traveller_Loop(Graph_T Graph, Traveller_T	Traveller, BOOLEAN	&Q_TravellerAssigned) {

	char 	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 't': Assign_Traveller_To_Vertex(Graph, Traveller, Q_TravellerAssigned);
				break;
			case 'a': Print_CurrentNext_Arc(Traveller);
				break;
			case 'f': Move_To_First_Arc(Traveller);
				break;
			case 'n': Move_To_Next_Arc(Traveller);
				break;
			case 'o': Move_Along_Current_Arc(Traveller);
				break;
			case 'p': Print_Current_Vertex(Traveller);
				break;
			case 'h': Check_Path(Graph);
				break;
			case 'm' : Traveller_Menu();
				break;
			default   : cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext  traveller request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Traveller_Finalise(Graph_T Graph, Traveller_T	&Traveller, BOOLEAN	&Q_TravellerAssigned) {

	cout	<< "Leaving traveller options";
	if (Q_TravellerAssigned) {
		Q_TravellerAssigned = FALSE;
		Destroy_Traveller(Traveller);
	}
}


//	PRE	NOT Q_EmptyGraph(Graph)
//	POST	Initialises, loops and finalises traveller options
void
Traveller_Main (Graph_T &Graph, Traveller_T	Traveller, BOOLEAN	&Q_TravellerAssigned) {
	if (!Q_EmptyGraph(Graph)) {
		Traveller_Initialise(Graph, Traveller, Q_TravellerAssigned);
		if (Q_TravellerAssigned) {
			Traveller_Loop(Graph, Traveller, Q_TravellerAssigned);
			Traveller_Finalise(Graph, Traveller, Q_TravellerAssigned);
		}
		else {
			cout	<<	"\nFailed to assign traveller"
					<<	"\nBack to main menu";
		}
	}
	else {
		cout	<<	"\nNo vertices in graph";
	}
}


// PRE	TRUE
// POST	menu displayed
void
Menu() {

	cout	<< "***   Main Menu            	  **************\n";
	cout	<< "***   add a new (v)ertex  	  **************\n";
	cout	<< "***   add a new (a)rc      	  **************\n";
	cout	<< "***   check (k)ey present  	  **************\n";
	cout	<< "***   (g)et vertex record  	  **************\n";
	cout	<< "***   (e)rase vertex record  	  ***********\n";
	cout	<< "***   (r)eset graph *************************\n";
	cout	<< "***   (u)nmark all vertices in graph ********\n";
	cout	<< "***   p(r)int vertices **********************\n";
	cout	<< "***   print ar(c)s  *************************\n";
	cout	<< "***   (l)oad graph from file ****************\n";
	cout	<< "***   write (s)ize of graph *****************\n";
	cout	<< "***   (t)raveller options *******************\n";
	cout	<< "***   this (m)enu	       	****************\n";
	cout	<< "***   e(x)it			        	****************\n";
}


// PRE	TRUE
// POST	Graph initialised
void
Initialise(Graph_T &Graph, Traveller_T	Traveller, BOOLEAN	&Q_TravellerAssigned) {

	Graph = Create_Graph();
	Q_TravellerAssigned = FALSE;
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(Graph_T Graph, Traveller_T	Traveller, BOOLEAN	&Q_TravellerAssigned) {

	char 	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'v': Add_NewVertex(Graph);
				break;
			case 'a': Add_NewArc(Graph);
				break;
			case 'k': Check_Vertex_Present(Graph);
				break;
			case 'g': Get_Vertex(Graph);
				break;
			case 'u': UnMark_All(Graph);
				break;
			case 'r': Print_Vertices(Graph);
				break;
			case 'c': Print_Arcs(Graph);
				break;
			case 's': Print_Size(Graph);
				break;
			case 't': Traveller_Main(Graph, Traveller, Q_TravellerAssigned);
				break;
			case 'h': Check_Path(Graph);
				break;
			case 'l': Load_Graph_From_File(Graph);
				break;
			case 'i': Initialise(Graph, Traveller, Q_TravellerAssigned);
				break;
			case 'm' : Menu();
				break;
			default   : cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(Graph_T Graph, Traveller_T	Traveller, BOOLEAN	Q_TravellerAssigned) {
	cout	<< "That is it !";
}

void
main () {
	Initialise(Graph, Traveller, Q_TravellerAssigned);
	Loop(Graph, Traveller, Q_TravellerAssigned);
	Finalise(Graph, Traveller, Q_TravellerAssigned);
}