// board.h
// demo program for ADT's
// Ken Brownsey 25/8/97


#include <stdlib.h>
#include "my_const.h"

#define	NumCols 8
#define 	NumRows 8

typedef enum SquareStatus_T {Empty, WhitePiece, BlackPiece};
typedef enum Direction_T {N, NE, E, SE, S, SW, W, NW, Invalid};

typedef int Row_T,
				Col_T;

typedef struct {
	Row_T Row;
	Col_T Col;
} Position_T;

typedef void *Board_T;


// PRE	TRUE
// POST	RETURNS an empty Board_T - i.e. memory allocated etc.
Board_T
Create_Board();


//	PRE 	TRUE
//	POST	RETURNS IF 	Position is on Board THEN TRUE
//			ELSE FALSE
BOOLEAN
Q_OnBoard(Position_T Position);


//	PRE		Q_OnBoard(Position, Board)
//	POST 	RETURNS content of Position on Board
enum SquareStatus_T
Get_Status(Position_T Position, Board_T Board);


//	PRE		TRUE
//	POST	RETURNS position in direction Direction from Position
Position_T
Get_NextPosition(Position_T Position, enum Direction_T Direction);


//	PRE		Q_OnBoard(Position, Board)
//	POST    content of Position on Board is Status
void
Set_Status(Position_T Position, enum SquareStatus_T Status, Board_T Board);


//	PRE     TRUE
//	POST	RETURNS point with first coordinate Row and second Col
Position_T
Make_Position(int Row, int Col);


// PRE	TRUE
// POST	IF Position is that of a black square
//			RETURNS True
//		ELSE
//			RETURNS False
BOOLEAN
Q_BlackSquare(Position_T Position);


//	PRE	TRUE
// POST	IF Position1 and Position2 are the same THEN
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_SamePosition(Position_T Position1, Position_T Position2);


// PRE  TRUE
// POST Prompts for and RETURNS a Position_T
Position_T
Read_Position();


//	PRE	TRUE
// POST	Position printed in Cartesian coordinate format to screen
void
Write_Position(Position_T Position);


// PRE  TRUE
// POST Prompts for and RETURNS a Direction_T
//		  IF the Direction_T read is not valid
//				RETURNS(Invalid)
Direction_T
Read_Direction();


//	PRE	TRUE
// POST	Direction printed as string to screen
void
Write_Direction(Direction_T Direction);


// PRE	TRUE
// POST	IF Direction is a valid one
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_ValidDirection(Direction_T Direction);


//	PRE	TRUE
// POST	RETURNS random valid Direction_T
Direction_T
Random_Direction();
