// checker.cpp
// 6/4/99
// Demonstrator of Board_T
// Ken Brownsey

#include <iostream.h>
#include"board.h"



Board_T	Board;


/* PRE	TRUE */
/* POST	prints menu */
void
Menu() {
	cout << "\n *************  add (w)hite piece        *****************";
	cout << "\n *************  add (b)lack piece        *****************";
	cout << "\n *************  move (p)iece             *****************";
	cout << "\n *************  (m)enu                   *****************";
	cout << "\n *************  e(x)it                   *****************";
}


/* PRE	TRUE */
/* POST Board displayed to screen */
void
Display_Board(Board_T Board) {
	int	Row,
		Col;
	Position_T	Position;
	enum SquareStatus_T Status;

	for (Row = 1; Row <= NumRows; Row++) {
		cout	<< "\n"
				<<	Row;
		for (Col = 1; Col <= NumCols; Col++) {
			Position = Make_Position(Row, Col);
			Status = Get_Status(Position, Board);
			switch(Status) {
				case Empty :
					if (Q_BlackSquare(Position)) {
						cout	<< "  ";
					}
					else {
						cout	<< " #";
					}
				break;

				case WhitePiece :
					cout	<< " W";
				break;

				case BlackPiece :
					cout	<< " B";
				break;
			}
		}
	}
	cout	<< "\n\n  ";
	for (Col = 1; Col <= NumCols; Col++) {
		cout 	<< Col
				<< " ";
	}
}


/* PRE	TRUE */
/* POST Board initialiased to Empty squares*/
void
Initialise_Board(Board_T Board) {
	int	Row,
			Col;
	Position_T	Position;

	for (Row = 1; Row <= NumRows; Row++) {
		for (Col = 1; Col <= NumCols; Col++) {
			Position = Make_Position(Row, Col);
			Set_Status(Position, Empty, Board);
		}
	}
}


/* PRE  TRUE */
/* POST	user prompted for board position
		AND IF position is a black square,
				status of postion becomes Status
			ELSE
				appropriate error message */
void
Add_Piece(enum SquareStatus_T Status, Board_T Board) {
	int	Row,
		Col;
	Position_T	Position;
	BOOLEAN Q_OK;

	Q_OK = TRUE;
	cout	<< "\nType in row number ==> ";
	cin 	>> Row;
	cout	<< "\nType in column number ==> ";
	cin	>> Col;
	Position = Make_Position(Row, Col);
	if (!Q_OnBoard(Position)) {
		cout 	<< "\nSquare ";
		Write_Position(Position);
		cout	<< " not on board";
		Q_OK = FALSE;
	}

	if (Q_OK) {
		if (!Q_BlackSquare(Position)) {
			cout 	<< "\nSquare ";
			Write_Position(Position);
			cout	<< " is white"
					<<	"\n and you can only add pieces to black squares"
               << "\n - i.e. the ones without the #";
			Q_OK = FALSE;
		}
	}

	if (Q_OK) {
		if (Get_Status(Position, Board) == Empty) {
			Set_Status(Position, Status, Board);
		}
		else {
			cout 	<< "\nSomething already in square ";
			Write_Position(Position);
		}
	}
}


/* PRE	On_Board(Position) AND OnBoard(NextPosition) */
/* POST	Get_Status(NextPosition)' = Get_Status(Position)
		AND Get_Status(Position)' = Empty */
void
Move_Piece(Position_T Position, Position_T NextPosition, Board_T Board) {
	Set_Status(NextPosition, Get_Status(Position, Board), Board);
	Set_Status(Position, Empty, Board);
}



/* PRE  TRUE */
/* POST	user prompted for board position
		AND IF position on Board contains a piece,
			user is prompted for a direction
			AND IF piece can move in that direction
					piece is moved in that direction
				ELSE
					appropriate error message
			ELSE
				appropriate error message */
void
Make_Move(Board_T Board) {
	int	Row,
		Col;
	Position_T	Position,
					NextPosition;
	BOOLEAN Q_OK;
	enum	Direction_T Direction;

	Q_OK = TRUE;

	Position = Read_Position();

	if (!Q_OnBoard(Position)) {
		cout 	<< "\nSquare ";
		Write_Position(Position);
		cout	<< " is not on the board";
		Q_OK = FALSE;
	}

	if (Q_OK) {
		if (Get_Status(Position, Board) == Empty) {
			cout 	<< "\nSquare ";
			Write_Position(Position);
			cout	<< " is empty";
			Q_OK = FALSE;
		}
	}


	if (Q_OK) {
		Direction = Read_Direction();
		if (!Q_ValidDirection(Direction)) {
			cout	<< "\n\nDirection is not a valid one\n";
			Q_OK = FALSE;
		}
	}

	if (Q_OK) {
		NextPosition = Get_NextPosition(Position, Direction);

		if (!Q_OnBoard(NextPosition)) {
			cout	<< "\nGoing ";
			Write_Direction(Direction);
			cout	<< " will move piece off board";
			Q_OK = FALSE;
		}
	}

	if (Q_OK) {
		if (!Get_Status(NextPosition, Board) == Empty) {
			cout << "\nBoard occupied to the ";
			Write_Direction(Direction);
			Q_OK = FALSE;
		}
	}

	if (Q_OK) {
		Move_Piece(Position, NextPosition, Board);
		if (!Q_BlackSquare(NextPosition)) {
			cout	<<	"\nIf you cannot put a new piece on a square that is white"
					<<	"\nUnless it's a strange game then it must not surely be right"
					<< "\nTo move onto such a square"
					<<	"\nUsing such good software"
					<<	"\nSo fix it now and save us all from such a plight";
		}
	}
}


/* PRE	TRUE */
/* POST	Sets up */
void
Initialise() {
	cout << "Here we go !\n";
	Initialise_Board(Board);
}


void
Loop() {

	char 	Request;
	int	RequestCount;

	for (Request = ' ', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'w' :
				Add_Piece(WhitePiece, Board);
			break;

			case 'b' :
				Add_Piece(BlackPiece, Board);
			break;

			case 'p' :
				Make_Move(Board);
			break;

			case 'm' :
				Menu();
			break;

			default   :
				cout << "\n m for menu \n";
			break;
		}
		Display_Board(Board);
		cout	<< "\n\nNext request ("
				<< RequestCount
				<< ") ==> ";
		cin	>> Request;
	}
}


/* PRE	TRUE */
/* POST	Clears up */
void
Finalise() {
	cout << "That is it !\n";
}


void
main() {
	Board = Create_Board();
	Initialise();
	Loop();
	Finalise();
}


