// numbers.cpp
// 8/4/99
// Demonstrates use of NumberDB_T = Sequence_T with Element_T = int
// Ken Brownsey

#include <iostream.h>
#include "sequence.h"

typedef Sequence_T NumberDB_T;
typedef int	Key_T;


// PRE	TRUE
// POST	IF Q_Empty(Nums)
//				Message to say so
//			ELSE
//				Message to say not empty
void
Test_Empty(NumberDB_T Nums) {
	if (Q_Empty(Nums)) {
		cout	<< "\nDatabase is empty\n";
	}
	else  {
		cout	<< "\nDatabase is not empty\n";
	}
}


// PRE	TRUE
// POST	IF Q_Full(Nums)
//				Message to say so
//			ELSE
//				Message to say not empty
void
Test_Full(NumberDB_T Nums) {
	if (Q_Full(Nums)) {
		cout	<< "\nDatabase is full\n";
	}
	else  {
		cout	<< "\nDatabase is not full\n";
	}
}


// PRE	TRUE
// POST	IF NOT Q_Empty(Nums)
//				IF Q_At_End(Nums)
//					Message to say so
//				ELSE
//					Message to say not at end
//			ELSE
//				Message to say empty
void
Test_End(NumberDB_T Nums) {
	if (!Q_Empty(Nums)) {
		if (Q_At_End(Nums)) {
			cout	<< "\nAt end of database\n";
		}
		else  {
			cout	<< "\nNot at end of database\n";
		}
	}
	else {
		cout <<	"\nDatabase is empty\n";
	}
}



// PRE	TRUE
// POST  IF NOT Q_Full(Numbers) THEN
//				user is prompted for integer NewInt
//				Numbers' = Append_After_Current(NewInt, Numbers)
//			ELSE appropriate message
void
Put_AfterCurrent(NumberDB_T Numbers) {
	int	NewInt;

	if (Q_Full(Numbers)) {
		cout	<< "Database is full";
	}
	else {
		cout	<< "Please type in new number ==> ";
		cin	>> NewInt;
		Append_After_Current(NewInt, Numbers);
	}
}


// PRE	TRUE
// POST  IF NOT Q_Full(Numbers) THEN
//				user is prompted for new record NewInt
//				Numbers' = Insert_Before_Current(NewInt, Numbers)
//			ELSE appropriate message
void
Put_BeforeCurrent(NumberDB_T Numbers) {
	int	NewInt;

	if (Q_Full(Numbers)) {
		cout	<< "Database is full";
	}
	else {
		if (Q_Empty(Numbers)) {
			cout	<< "Database is empty";
		}
		else {
			cout	<< "Please type in new number ==> ";
			cin	>>	NewInt;
			Insert_Before_Current(NewInt, Numbers);
		}
	}
}


// PRE	TRUE
// POST  IF NOT Q_Empty(Numbers) THEN
//				Numbers' = Delete_Current(Numbers)
//			ELSE appropriate message
void
Remove_Current(NumberDB_T Numbers) {

	if (Q_Empty(Numbers)) {
		cout	<< "Database is empty";
	}
	else {
		Delete_Current(Numbers);
	}
}


// PRE	TRUE
// POST  IF NOT Q_Empty(Numbers) THEN
//				current element is printed to screen
//			ELSE appropriate message
void
Print_Current(NumberDB_T Numbers) {

	if (Q_Empty(Numbers)) {
		cout	<< "Database is empty";
	}
	else {
		cout	<<	Get_Current(Numbers);
	}
}


// PRE	TRUE
// POST  IF NOT Q_Empty(Numbers) AND NOT Q_At_End(Numbers)
//				Numbers' = Go_To_Next(Numbers)
//			ELSE
//				appropriate message
void
Move_Forward(NumberDB_T Numbers) {

	if (Q_Empty(Numbers)) {
		cout	<< "Database is empty";
	}
	else {
		if (Q_At_End(Numbers)) {
			cout	<< "At end of database";
		}
		else {
			Go_To_Next(Numbers);
		}
	}
}


// PRE	TRUE
// POST  IF NOT Q_Empty(Numbers)
//				Numbers' = Go_To_Head(Numbers)
//			ELSE appropriate message
void
Move_ToHead(NumberDB_T Numbers) {

	if (Q_Empty(Numbers)) {
		cout	<< "Database is empty";
	}
	else {
		Go_To_Head(Numbers);
	}
}



// PRE	NOT Q_Empty_Sequence(Nums)
// POST  RETURNS number of elements in Nums
//			AND Q_At_End(Nums')
// NOTES	this is a function with side effects
int
Find_Size(NumberDB_T Nums) {

int	Size;

	Go_To_Head(Nums);
	for (Size = 1; !Q_At_End(Nums); Size++) {
		Go_To_Next(Nums);
	}
	return(Size);
}


// PRE	TRUE
// IF Q_Empty(Nums) THEN
//		appropriate message
//	ELSE prints out number of elements in Nums
//			AND Q_At_End(Nums')
void
Print_Size(NumberDB_T Nums) {

	if (Q_Empty(Nums)) {
		cout 	<< "\nEmpty database - 0 records\n";
	}
	else {
		cout  << "\nNumber of elements is "
				<< Find_Size(Nums)
				<<	"\n";
	}
}


// PRE	NOT Q_Empty_Sequence(Numbers)
// POST  RETURNS total of elements in Numbers
//			AND Q_At_End(Numbers')
// NOTES	this is a function with side effects
int
Find_Total(NumberDB_T Nums) {

int	Total;

	Go_To_Head(Nums);
	for (Total = Get_Current(Nums); !Q_At_End(Nums);) {
		Go_To_Next(Nums);
		Total = Total + Get_Current(Nums);
	}
	return(Total);
}


// PRE	TRUE
// POST	IF Q_Empty(Nums)
//				appropriate message
//			ELSE
//				prints out total of elements in Nums
//				AND Q_At_End(Nums')
void
Print_Total(NumberDB_T Nums) {

	if (Q_Empty(Nums)) {
		cout 	<< "\nEmpty database nothing to total\n";
	}
	else {
		cout  << "\nTotal of elements is "
				<< Find_Total(Nums)
				<<	"\n";
	}
}


//	PRE	TRUE
// POST	IF Key is an element of Nums
//				Get_Current(Nums) = Key
//				AND RETURNS TRUE
//			ELSE
//				IF NOT Q_Empty(Nums)
//					Q_At_End(Nums)
//				RETURNS FALSE
// NOTES	this is a function with side effects
BOOLEAN
Q_Present(int Key, NumberDB_T Nums) {
	BOOLEAN	Q_Found;

	if (Q_Empty(Nums)) {
		return(FALSE);
	}
	else {
		Go_To_Head(Nums);
		Q_Found = FALSE;
		for(;!Q_At_End(Nums) && !Q_Found;) {
			if (Get_Current(Nums) == Key) {
				Q_Found = TRUE;
				// NOT Q_At_End(Nums)
			}
			else {
				Go_To_Next(Nums);
			}
		}
		//	EITHER	Q_Found AND Get_Current(Nums) = Key
		//	OR       Q_At_End(Nums) AND Get_Current(Nums) = Key
		//	OR			Q_At_End(Nums) AND Get_Current(Nums) <> Key
		return(Get_Current(Nums) == Key);
	}
}


// PRE	TRUE
// POST	User is prompted for Key value Key
// 		IF there Key is an element of Nums
//				Get_Current(Nums) = Key
//				AND prints appropriate message
//			ELSE
//				IF NOT Q_Empty(Nums)
//					Q_At_End(Nums)
//				Prints appropriate message
void
Check_Key(NumberDB_T Nums) {
	Key_T	Key;

	cout	<<	"\n\nPlease type in key value to check ==> ";
	cin	>> Key;
	if (Q_Present(Key, Nums)) {
		cout	<< "\nKey value "
				<<	Key
				<<	" has been located\n";
	}
	else {
		cout	<< "\nKey value "
				<<	Key
				<<	" is not in the database\n";
	}
}


//	PRE	TRUE
//	POST	IF NOT Q_Empty(Nums)
//				all values are printed to screen
//				AND Q_At_End(Nums')
//			ELSE message to say that Nums is empty
void
Print_All(NumberDB_T Nums) {

	if (!Q_Empty(Nums)) {
		cout	<< "\n******************\nContents of the table are as follows\n\n";
		Go_To_Head(Nums);
		for(;!Q_At_End(Nums);) {
			cout	<<	Get_Current(Nums);
			Go_To_Next(Nums);
			cout	<< "\n";
		}
		cout	<<	Get_Current(Nums);
		cout	<< ("\n******************\nThat's all!\n");
	}
	else {
		cout	<< ("\nDatabase is empty - nothing to print\n\n");
	}
}


//	PRE	TRUE
// POST	Q_Empty(Nums)
void
Make_Empty(NumberDB_T Nums) {
	for(;!Q_Empty(Nums);) {
		Delete_Current(Nums);
	}
}


//	PRE	Q_Empty(Nums2)
//	POST	Nums2' is Nums1 reversed
//			AND Q_Empty(Nums1')
//			AND Q_At_End(Nums2')
void
Reverse(NumberDB_T Nums1, NumberDB_T Nums2) {
	if (!Q_Empty(Nums1)) {
		Go_To_Head(Nums1);
		Append_After_Current(Get_Current(Nums1), Nums2);
		Delete_Current(Nums1);
		for(;!Q_Empty(Nums1);) {
			Insert_Before_Current(Get_Current(Nums1), Nums2);
			Go_To_Head(Nums2);
			Delete_Current(Nums1);
		}
	}
}


//	PRE	Q_Empty(Nums2)
//	POST	Each element in Nums2' is
//			corresponding element in Nums1 times Factor
//			AND Q_At_End(Nums1')
//			AND Q_At_End(Nums2')
void
Multiply(NumberDB_T Nums1, NumberDB_T Nums2, int Factor) {
	if (!Q_Empty(Nums1)) {
		Go_To_Head(Nums1);
		Append_After_Current(Factor * Get_Current(Nums1), Nums2);
		for(;!Q_At_End(Nums1);) {
			Go_To_Next(Nums1);
			Append_After_Current(Factor * Get_Current(Nums1), Nums2);
			Go_To_Next(Nums2);
		}
	}
}


//	PRE	TRUE
//	POST	User is pormpted for Factor
//			AND Each element in Nums2' is
//			corresponding element in Nums1 times Factor
//			AND Q_At_End(Numbers')
void
Multiply_By_Factor(NumberDB_T Nums1, NumberDB_T Nums2) {
	int	Factor;

	cout	<< "Please type in factor ==> ";
	cin	>> Factor;
	Make_Empty(Nums2);
	Multiply(Nums1, Nums2, Factor);
}


//	PRE	NOT Q_Empty(Nums)
//	POST	RETURNS largest element in Nums
//			AND Q_At_End(Numbers')
// NOTES	this is a function with side effects
int
Find_Maximum(NumberDB_T Nums) {
	int	MaxSoFar;

	Go_To_Head(Nums);
	MaxSoFar = Get_Current(Nums);
	for(;!Q_At_End(Nums);) {
		Go_To_Next(Nums);
		if (Get_Current(Nums) > MaxSoFar) {
			MaxSoFar = Get_Current(Nums);
		}
	}
	return(MaxSoFar);
}


//	PRE	TRUE
//	POST	IF NOT Q_Empty(Nums)
//				Prints out largest element of Nums
//			ELSE
//				Message to say that Nums is empty
void
Print_Biggest(NumberDB_T Nums) {
	int	Factor;

	if (!Q_Empty(Nums)) {
		cout	<< "\nThe biggest of ";
		Print_All(Nums);
		cout	<<	" is "
				<< Find_Maximum(Nums)
				<<	"\n\n";
	}
	else {
		cout	<<"\n\nThe database of numbers is empty\n";
	}
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	test to see if data base is (e)mpty *****\n"
			<<	"***	test to see if data base is f(u)ll ******\n"
			<<	"***	test to see if at e(n)d of data base ****\n"
			<<	"***	(a)ppend a new record after current *****\n"
			<<	"***	(i)nsert a new record before current ****\n"
			<<	"***	(r)emove current ************************\n"
			<<	"***	move current element (f)orward **********\n"
			<<	"***	make current element (h)ead *************\n"
			<< "***	(p)rint current record     **************\n"
			<< "***	print (s)ize of database   **************\n"
			<< "***	print tota(l) of database   *************\n"
			<< "***	print bi(g)gest element of database  ****\n"
			<< "***	(c)heck key present in database   *******\n"
			<< "***	print(t) all the database   *************\n"
			<< "***	re(v)erse the numbers -->   *************\n"
			<< "***	reverse the num(b)ers <--   *************\n"
			<< "***	multipl(y) the numers   *****************\n"
			<< "***	prin(t) all the database   **************\n"
			<< "***	print all the (o)ther numbers ***********\n"
			<< "***   e(x)it					      **************\n"
			<< "***   (m)enu						   **************\n";
}


// PRE	TRUE
// POST	Initialisation is done
void
Initialise(NumberDB_T &Nums) {

	Nums = Create_Sequence();
	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(NumberDB_T Nums) {

	char	Request;
	int	RequestCount;
	NumberDB_T	OtherNums;

	OtherNums = Create_Sequence();
	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'e' :	Test_Empty(Nums);
				break;
			case 'u' :	Test_Full(Nums);
				break;
			case 'n' :	Test_End(Nums);
				break;
			case 'a' :	Put_AfterCurrent(Nums);
				break;
			case 'i' :	Put_BeforeCurrent(Nums);
				break;
			case 'r' :	Remove_Current(Nums);
				break;
			case 'p' :	Print_Current(Nums);
				break;
			case 'f' :	Move_Forward(Nums);
				break;
			case 'h' :	Move_ToHead(Nums);
				break;
			case 's' :	Print_Size(Nums);
				break;
			case 'c' :	Check_Key(Nums);
				break;
			case 't' :	Print_All(Nums);
				break;
			case 'l' :	Print_Total(Nums);
				break;
			case 'g' :	Print_Biggest(Nums);
				break;
			case 'v'	:	Make_Empty(OtherNums);
							Reverse(Nums, OtherNums);
				break;
			case 'b'	:	Make_Empty(Nums);
							Reverse(OtherNums, Nums);
				break;
			case 'y'	:	Multiply_By_Factor(Nums, OtherNums);
				break;
			case 'o' :	Print_All(OtherNums);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(NumberDB_T Nums) {
	for(;!Q_Empty(Nums);) {
		Delete_Current(Nums);
	}
	Free_Sequence(Nums);
	cout	<< "That is it !\n";
}


void
main() {
	NumberDB_T	Numbers;

	Initialise(Numbers);
	Loop(Numbers);
	Finalise(Numbers);
}