// sequence.cpp
// 1/8/98
// Sequence_T implementation based on array
// Ken Brownsey

#include "sequence.h"
#include <iostream.h>
#define MaxElements 4

typedef struct {
	KAPRec_T	Recs[MaxElements];
	int	CurrentElement,
			NumberElements;
} SeqRec_T, *SeqRec_Ptr_T;


// PRE	TRUE
// POST	RETURNS an initialised Sequence_T
Sequence_T
Create_Sequence() {
	SeqRec_Ptr_T NewSeq;

	NewSeq = new SeqRec_T;
	NewSeq->NumberElements = 0;
	return((Sequence_T) NewSeq);
}


// PRE	TRUE
//	POST	IF Sequence is full THEN
//				RETURNS TRUE
//			ELSE RETURNS FALSE
BOOLEAN
Q_Full(Sequence_T Sequence) {
	SeqRec_Ptr_T Seq;

	Seq = (SeqRec_Ptr_T) Sequence;
	return(Seq->NumberElements == MaxElements);
}


// PRE	TRUE
//	POST	IF Sequence is empty THEN RETURNS TRUE
//			ELSE RETURNS FALSE
BOOLEAN
Q_Empty(Sequence_T Sequence) {
	SeqRec_Ptr_T Seq;

	Seq = (SeqRec_Ptr_T) Sequence;
	return(Seq->NumberElements == 0);
}


// PRE	NOT Q_Empty(Sequence)
//	POST	IF current element last in Sequence THEN
//				RETURNS TRUE
//			ELSE RETURNS FALSE
BOOLEAN
Q_At_End(Sequence_T Sequence){

	cout	<< "\nYou need to not fall off the end"
			<< "\nEvery mental fibre must bend"
			<< "\nTo prevent disaster"
			<< "\nAnd at last to master"
			<< "\nThe code that gives the result you intend\n";
}


// PRE	NOT Q_Empty(Sequence)
//	POST	first element of Sequence' is the current element
void
Go_To_Head(Sequence_T Sequence) {
	cout	<< "\nNeed to be able to get to the front"
			<< "\nThis is not really such a tricky stunt"
			<< "\nLook at the types"
			<< "\nHold back the gripes"
			<< "\nAnd start working on the inspiration hunt\n";
}


// PRE	NOT Q_Empty(Sequence) AND
//			NOT Q_At_End(Sequence)
//	POST	current element in Sequence' is the one after
//			current element in Sequence
void
Go_To_Next(Sequence_T Sequence) {
	SeqRec_Ptr_T Seq;

	Seq = (SeqRec_Ptr_T) Sequence;
	(Seq->CurrentElement)++;
}


// PRE	NOT Q_Empty(Sequence)
// POST	RETURNS current record
Element_T
Get_Current(Sequence_T Sequence) {
	SeqRec_Ptr_T Seq;

	Seq = (SeqRec_Ptr_T) Sequence;
	return(Seq->Recs[Seq->CurrentElement]);
}


// PRE	TRUE
// POST	Sequence' = Sequence with NewRec added AND
//			IF Q_Empty(Sequence) THEN
//				current of Sequence' is first element
//			ELSE
//				NewRec is after current in Sequence'
void
Append_After_Current(Element_T NewRec, Sequence_T Sequence) {
	SeqRec_Ptr_T Seq;
	int Index;

	Seq = (SeqRec_Ptr_T) Sequence;
	if (Q_Empty(Seq)) {
		Seq->CurrentElement = 0;
		Seq->NumberElements = 1;
		Seq->Recs[0] = NewRec;
	}
	else {
		for (	Index = Seq->NumberElements - 1;
				Index > Seq->CurrentElement;
				Index--) {
			Seq->Recs[Index + 1] = Seq->Recs[Index];
		}
		// Index = Seq->CurrentElement
		Seq->Recs[Seq->CurrentElement + 1] = NewRec;
		(Seq->NumberElements)++;
	}
}


// PRE	NOT Q_Empty(Sequence)
// POST	Sequence' = Sequence with NewRec added AND
//			NewRec is before current in Sequence'
void
Insert_Before_Current(Element_T NewRec, Sequence_T Sequence) {
	cout	<< "\nNow a procedure to insert before"
			<< "\nBut this is really not such a big chore"
			<< "\nA good program crafter"
			<< "\nLooks at append after"
			<< "\nTo get some clues before doing any more\n";
}


// PRE	NOT Q_Empty(Sequence)
// POST	Sequence' = Sequence with current of Sequence removed AND
//			IF NOT(Q_Empty(Sequence'))
//				current of Sequence' is first element of Sequence'
void
Delete_Current(Sequence_T Sequence) {
	cout	<< "\nIt looks as if the database gets quite packed"
			<< "\nA procedure for deleting is rather lacked"
			<< "\nA diagram is needed"
			<< "\nAnd notes should be heeded"
			<< "\nBecause this is one procedure that just cannot be hacked\n";
}


//	PRE	Q_Empty(Sequence)
//	POST	all memory allocated to Sequence is freed up
// NOTES	Sequence will need to be re-initialised
//			with Create_Sequence() before being used again
void
Free_Sequence(Sequence_T Sequence) {
	SeqRec_Ptr_T Seq;

	Seq = (SeqRec_Ptr_T) Sequence;
	delete(Seq);
}
