// stud_db.cpp
// 1/8/98
// Demonstrates use of StudentDB_T with DataRec_T = StudentRec_T
// Ken Brownsey

#include <iostream.h>
#include "sequence.h"

typedef Sequence_T StudentDB_T;



// PRE	TRUE
// POST	IF Q_Empty(DB)
//				Message to say so
//			ELSE
//				Message to say not empty
void
Test_Empty(StudentDB_T DB) {
	if (Q_Empty(DB)) {
		cout	<< "\nDatabase is empty\n";
	}
	else  {
		cout	<< "\nDatabase is not empty\n";
	}
}


// PRE	TRUE
// POST	IF Q_Full(DB)
//				Message to say so
//			ELSE
//				Message to say not empty
void
Test_Full(StudentDB_T DB) {
	if (Q_Full(DB)) {
		cout	<< "\nDatabase is full\n";
	}
	else  {
		cout	<< "\nDatabase is not full\n";
	}
}


// PRE	TRUE
// POST	IF NOT Q_Empty(DB)
//				IF Q_At_End(DB)
//					Message to say so
//				ELSE
//					Message to say not at end
//			ELSE
//				Message to say empty
void
Test_End(StudentDB_T DB) {
	if (!Q_Empty(DB)) {
		if (Q_At_End(DB)) {
			cout	<< "\nAt end of database\n";
		}
		else  {
			cout	<< "\nNot at end of database\n";
		}
	}
	else {
		cout <<	"\nDatabase is empty\n";
	}
}



// PRE	TRUE
// POST  IF NOT Q_Full(DataBase) THEN
//				user is prompted for fraction Frac
//				AND IF NOT Q_ZeroDen(Frac) THEN
//						DataBase' = Append_After_Current(Frac, DataBase)
//					ELSE appropriate message
//			ELSE appropriate message
void
Put_AfterCurrent(StudentDB_T DataBase) {
	DataRec_T	NewRec;
	KAPRec_T		KAPRec;

	if (Q_Full(DataBase)) {
		cout	<< "Database is full";
	}
	else {
		cout	<< "Please type in new record\n";
		Read_Rec(NewRec);
		KAPRec = Make_KAPRec(NewRec);
		Append_After_Current(KAPRec, DataBase);
	}
}


// PRE	TRUE
// POST  IF NOT Q_Full(DataBase) AND NOT Q_Empty(DataBase) THEN
//				user is prompted for fraction Frac
//				AND IF NOT Q_ZeroDen(Frac) THEN
//						DataBase' = Insert_Before_Current(Frac, DataBase)
//					ELSE appropriate message
//			ELSE appropriate message
void
Put_BeforeCurrent(StudentDB_T DataBase) {
	DataRec_T	NewRec;
	KAPRec_T		KAPRec;

	if (Q_Full(DataBase)) {
		cout	<< "Database is full";
	}
	else {
		if (Q_Empty(DataBase)) {
			cout	<< "Database is empty";
		}
		else {
			cout	<< "Please type in new record\n";
			Read_Rec(NewRec);
			KAPRec = Make_KAPRec(NewRec);
			Insert_Before_Current(KAPRec, DataBase);
		}
	}
}


// PRE	TRUE
// POST  IF NOT Q_Empty(DataBase) THEN
//				DataBase' = Delete_Current(DataBase)
//			ELSE appropriate message
void
Remove_Current(StudentDB_T DataBase) {

	if (Q_Empty(DataBase)) {
		cout	<< "Database is empty";
	}
	else {
		Free_RecMemory(Get_Current(DataBase));
		Delete_Current(DataBase);
	}
}


// PRE	TRUE
// POST  IF NOT Q_Empty(DataBase) THEN
//				current element is printed to screen
//			ELSE appropriate message
void
Print_Current(StudentDB_T DataBase) {

	if (Q_Empty(DataBase)) {
		cout	<< "Database is empty";
	}
	else {
		Write_Rec(Get_DataRec(Get_Current(DataBase)));
	}
}


// PRE	TRUE
// POST  IF NOT Q_Empty(DataBase) AND NOT Q_At_End(DataBase)
//				DataBase' = Go_To_Next(DataBase)
//			ELSE appropriate message
void
Move_Forward(StudentDB_T DataBase) {

	if (Q_Empty(DataBase)) {
		cout	<< "Database is empty";
	}
	else {
		if (Q_At_End(DataBase)) {
			cout	<< "At end of database";
		}
		else {
			Go_To_Next(DataBase);
		}
	}
}


// PRE	TRUE
// POST  IF NOT Q_Empty(DataBase)
//				DataBase' = Go_To_Head(DataBase)
//			ELSE appropriate message
void
Move_ToHead(StudentDB_T DataBase) {

	if (Q_Empty(DataBase)) {
		cout	<< "Database is empty";
	}
	else {
		Go_To_Head(DataBase);
	}
}



// PRE	NOT Q_Empty_Sequence(DataBase)
// POST  RETURNS number of elements in DataBase
//			AND DataBase' = Go_To_Head(DataBase)
// NOTES	this is a function with side effects
int
Find_Size(StudentDB_T DB) {

int	Size;

	Go_To_Head(DB);
	for (Size = 1; !Q_At_End(DB); Size++) {
		Go_To_Next(DB);
	}
	Go_To_Head(DB);
	return(Size);
}


// PRE	TRUE
// IF Q_Empty(DB) THEN
//		appropriate message
//	ELSE prints out number of elements in DB
//			AND DB' = Go_To_Head(DB)
void
Print_Size(StudentDB_T DB) {

	if (Q_Empty(DB)) {
		cout 	<< "\nEmpty database - 0 records\n";
	}
	else {
		cout  << "\nNumber of elements is "
				<< Find_Size(DB)
				<<	"\n";
	}
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	test to see if data base is (e)mpty *****\n"
			<<	"***	test to see if data base is f(u)ll ******\n"
			<<	"***	test to see if at e(n)d of data base ****\n"
			<<	"***	(a)ppend a new record after current *****\n"
			<<	"***	(i)nsert a new record before current ****\n"
			<<	"***	(r)emove current ************************\n"
			<<	"***	move current element (f)orward **********\n"
			<<	"***	make current element (h)ead *************\n"
			<< "***	(p)rint current record     **************\n"
			<< "***	print (s)ize of database   **************\n"
			<< "***   e(x)it					      **************\n"
			<< "***   (m)enu						   **************\n";
}


// PRE	TRUE
// POST	Initialisation is done
void
Initialise(StudentDB_T *DB_Ptr) {

	(*DB_Ptr) = Create_Sequence();
	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(StudentDB_T DB) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'e' :	Test_Empty(DB);
				break;
			case 'u' :	Test_Full(DB);
				break;
			case 'n' :	Test_End(DB);
				break;
			case 'a' :	Put_AfterCurrent(DB);
				break;
			case 'i' :	Put_BeforeCurrent(DB);
				break;
			case 'r' :	Remove_Current(DB);
				break;
			case 'p' :	Print_Current(DB);
				break;
			case 'f' :	Move_Forward(DB);
				break;
			case 'h' :	Move_ToHead(DB);
				break;
			case 's' :	Print_Size(DB);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(StudentDB_T DB) {
//	for(;!Q_Empty(DB);) {
//		Delete_Current(DB);
//	}
//	Free_Sequence(DB);
	cout	<< "That is it !\n";
}


void
main() {
	StudentDB_T	DataBase;

	Initialise(&DataBase);
	Loop(DataBase);
	Finalise(DataBase);
}