// data.h
// 6/8/98
// token records for parsing and evaluating
// Ken Brownsey

#include "lex.h"

typedef void *ArithToken_T;
typedef ArithToken_T Element_T;
typedef int	Precedence_T;


//	PRE	TRUE
// POST	Read_Rec can be used
// NOTES	This flushes any left over from standard cin operations
//			any number of Read_Rec's can be performed until the next regular
//			cin operation
void
Flush_For_Read();


// PRE	TRUE
//	POST	Reads up to the next newline
// NOTES to be used when Q_LexOK() is FALSE
void
Parse_Error_Recovery();



// PRE	Flush_For_Read() has been executed since last regular cin operation
// POST	ArithToken is the next token read from standard input
void
Read_Rec(ArithToken_T &ArithToken, BOOLEAN &Q_ReadOK);


// PRE	Q_ValidAT()
// POST	Writes value of ArithToken_T to screen
void
Write_Rec(ArithToken_T ArithToken);


// PRE	TRUE
// POST	IF ArithToken is LRB
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_LRB(ArithToken_T ArithToken);


// PRE	TRUE
// POST	IF ArithToken is RRB
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_RRB(ArithToken_T ArithToken);


// PRE	TRUE
// POST	IF ArithToken is Operator
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_Op(ArithToken_T ArithToken);


// PRE	TRUE
// POST	IF ArithToken is an integer
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_Int(ArithToken_T ArithToken);


// PRE	TRUE
// POST	IF ArithToken is an new line
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_NL(ArithToken_T ArithToken);


// PRE	Q_Op(ArithToken)
// POST	RETURNS precedence of operator in ArithToken
Precedence_T
Get_Precedence(ArithToken_T ArithToken);


// PRE	Q_Int(AT1) AND Q_Op(AT2) AND Q_Int(AT3)
// POST	RETURNS result of (infix) AT1 AT2 AT3
ArithToken_T
Evaluate(ArithToken_T AT1, ArithToken_T AT2, ArithToken_T AT3);

//	PRE	-	TRUE
//	POST	- 	all separator tokens skipped until next non-separator token,
//				which is then the current token
void
Skip_Separators();

