// token_db.cpp
// 1/8/98
// Demonstrates use of Sequence_T with Element_T = ArithToken_T
// Ken Brownsey

#include <iostream.h>
#include "sequence.h"

typedef Sequence_T ArithTokenDB_T;



// PRE	TRUE
// POST	IF Q_Empty(DB)
//				Message to say so
//			ELSE
//				Message to say not empty
void
Test_Empty(ArithTokenDB_T DB) {
	if (Q_Empty(DB)) {
		cout	<< "\nDatabase is empty\n";
	}
	else  {
		cout	<< "\nDatabase is not empty\n";
	}
}


// PRE	TRUE
// POST	IF Q_Full(DB)
//				Message to say so
//			ELSE
//				Message to say not empty
void
Test_Full(ArithTokenDB_T DB) {
	if (Q_Full(DB)) {
		cout	<< "\nDatabase is full\n";
	}
	else  {
		cout	<< "\nDatabase is not full\n";
	}
}


// PRE	TRUE
// POST	IF NOT Q_Empty(DB)
//				IF Q_At_End(DB)
//					Message to say so
//				ELSE
//					Message to say not at end
//			ELSE
//				Message to say empty
void
Test_End(ArithTokenDB_T DB) {
	if (!Q_Empty(DB)) {
		if (Q_At_End(DB)) {
			cout	<< "\nAt end of database\n";
		}
		else  {
			cout	<< "\nNot at end of database\n";
		}
	}
	else {
		cout <<	"\nDatabase is empty\n";
	}
}


// PRE	TRUE
// POST  IF NOT Q_Full(DataBase) THEN
//				user is prompted for fraction Frac
//				AND IF NOT Q_ZeroDen(Frac) THEN
//						DataBase' = Append_After_Current(Frac, DataBase)
//					ELSE appropriate message
//			ELSE appropriate message
void
Put_AfterCurrent(ArithTokenDB_T DataBase) {
	ArithToken_T	ArithToken;
	BOOLEAN	Q_OKRead;

	if (Q_Full(DataBase)) {
		cout	<< "Database is full";
	}
	else {
		cout	<< "Please type in new token\n";
		Flush_For_Read();
		Read_Rec(ArithToken, Q_OKRead);
		if (Q_OKRead) {
			Append_After_Current(ArithToken, DataBase);
		}
		else {
			cout	<< "\nInvalid Token Type\n";
		}
	}
}


// PRE	TRUE
// POST  IF NOT Q_Full(DataBase) AND NOT Q_Empty(DataBase) THEN
//				user is prompted for fraction Frac
//				AND IF NOT Q_ZeroDen(Frac) THEN
//						DataBase' = Insert_Before_Current(Frac, DataBase)
//					ELSE appropriate message
//			ELSE appropriate message
void
Put_BeforeCurrent(ArithTokenDB_T DataBase) {
	ArithToken_T	ArithToken;
	BOOLEAN	Q_OKRead;

	if (Q_Full(DataBase)) {
		cout	<< "Database is full";
	}
	else {
		if (Q_Empty(DataBase)) {
			cout	<< "Database is empty";
		}
		else {
			cout	<< "Please type in new token\n";
			Flush_For_Read();
			Read_Rec(ArithToken, Q_OKRead);
			if (Q_OKRead) {
				Insert_Before_Current(ArithToken, DataBase);
			}
			else {
				cout	<< "\nInvalid Token Type\n";
			}
		}
	}
}


// PRE	TRUE
// POST  IF NOT Q_Empty(DataBase) THEN
//				DataBase' = Delete_Current(DataBase)
//			ELSE appropriate message
void
Remove_Current(ArithTokenDB_T DataBase) {

	if (Q_Empty(DataBase)) {
		cout	<< "Database is empty";
	}
	else {
		Delete_Current(DataBase);
	}
}


// PRE	TRUE
// POST  IF NOT Q_Empty(DataBase) THEN
//				current element is printed to screen
//			ELSE appropriate message
void
Print_Current(ArithTokenDB_T DataBase) {

	if (Q_Empty(DataBase)) {
		cout	<< "Database is empty";
	}
	else {
		Write_Rec(Get_Current(DataBase));
	}
}


// PRE	TRUE
// POST  IF NOT Q_Empty(DataBase) AND NOT Q_At_End(DataBase)
//				DataBase' = Go_To_Next(DataBase)
//			ELSE appropriate message
void
Move_Forward(ArithTokenDB_T DataBase) {

	if (Q_Empty(DataBase)) {
		cout	<< "Database is empty";
	}
	else {
		if (Q_At_End(DataBase)) {
			cout	<< "At end of database";
		}
		else {
			Go_To_Next(DataBase);
		}
	}
}


// PRE	TRUE
// POST  IF NOT Q_Empty(DataBase)
//				DataBase' = Go_To_Head(DataBase)
//			ELSE appropriate message
void
Move_ToHead(ArithTokenDB_T DataBase) {

	if (Q_Empty(DataBase)) {
		cout	<< "Database is empty";
	}
	else {
		Go_To_Head(DataBase);
	}
}



// PRE	NOT Q_Empty_Sequence(DataBase)
// POST  RETURNS number of elements in DataBase
//			AND DataBase' = Go_To_Head(DataBase)
// NOTES	this is a function with side effects
int
Find_Size(ArithTokenDB_T DB) {

int	Size;

	Go_To_Head(DB);
	for (Size = 1; !Q_At_End(DB); Size++) {
		Go_To_Next(DB);
	}
	Go_To_Head(DB);
	return(Size);
}


// PRE	TRUE
// IF Q_Empty(DB) THEN
//		appropriate message
//	ELSE prints out number of elements in DB
//			AND DB' = Go_To_Head(DB)
void
Print_Size(ArithTokenDB_T DB) {

	if (Q_Empty(DB)) {
		cout 	<< "\nEmpty database - 0 records\n";
	}
	else {
		cout  << "\nNumber of elemnts is "
				<< Find_Size(DB)
				<<	"\n";
	}
}



// PRE	TRUE
// POST  IF DataBase has three or more elements
//				AND first is an integer token
//				AND second is an operatorr token
//				AND third is an integerr token
//				works out value of these three as an arithemtic expression
//				AND replaces first three elements with this value as a token
void
Work_Out_Top3(ArithTokenDB_T DB) {
	BOOLEAN	Q_OK;
	ArithToken_T	AT1,
						AT2,
						AT3;

	Q_OK = TRUE;

	if (Find_Size(DB) < 3) {
		cout	<< "\nNot enough tokens in the database\n";
		Q_OK = FALSE;
	}
	if (Q_OK) {
		Go_To_Head(DB);
		if (!Q_Int(Get_Current(DB))) {
			cout	<< "\nFirst element is not an integer\n";
			Q_OK = FALSE;
		}
	}

	if (Q_OK) {
		Go_To_Next(DB);
		if (!Q_Op(Get_Current(DB))) {
			cout	<< "\nSecond element is not an operator\n";
			Q_OK = FALSE;
		}
	}

	if (Q_OK) {
		Go_To_Next(DB);
		if (!Q_Int(Get_Current(DB))) {
			cout	<< "\nThird element is not an integerr\n";
			Q_OK = FALSE;
		}
	}

	if (Q_OK) {
		Go_To_Head(DB);
		AT1 = Get_Current(DB);
		Delete_Current(DB);
		AT2 = Get_Current(DB);
		Delete_Current(DB);
		AT3 = Get_Current(DB);
		Delete_Current(DB);
		if (Q_Empty(DB)) {
			Append_After_Current(Evaluate(AT1, AT2, AT3), DB);
		}
		else {
			Insert_Before_Current(Evaluate(AT1, AT2, AT3), DB);
         Go_To_Head(DB);
		}
	}
	else {
		cout	<< "\nNo evalaution done";
	}
}

// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	(a)ppend a new token after current *****\n"
			<<	"***	(i)nsert a new token before current ****\n"
			<<	"***	(r)emove current ************************\n"
			<<	"***	move (f)orward to next token   **********\n"
			<<	"***	move to (h)ead token        *************\n"
			<< "***	(p)rint current token      **************\n"
			<< "***	print (s)ize of database   **************\n"
			<< "***	(w)ork out top 3 as expression **********\n"
			<< "***   e(x)it					      **************\n"
			<< "***   (m)enu						   **************\n";
}


// PRE	TRUE
// POST	Initialisation is done
void
Initialise(ArithTokenDB_T *DB_Ptr) {

	(*DB_Ptr) = Create_Sequence();
	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(ArithTokenDB_T DB) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'a' :	Put_AfterCurrent(DB);
				break;
			case 'i' :	Put_BeforeCurrent(DB);
				break;
			case 'r' :	Remove_Current(DB);
				break;
			case 'p' :	Print_Current(DB);
				break;
			case 'f' :	Move_Forward(DB);
				break;
			case 'h' :	Move_ToHead(DB);
				break;
			case 's' :	Print_Size(DB);
				break;
			case 'w' :	Work_Out_Top3(DB);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(ArithTokenDB_T DB) {
//	for(;!Q_Empty(DB);) {
//		Delete_Current(DB);
//	}
//	Free_Sequence(DB);
	cout	<< "That is it !\n";
}


void
main() {
	ArithTokenDB_T	DataBase;

	Initialise(&DataBase);
	Loop(DataBase);
	Finalise(DataBase);
}