// Ken Brownsey
// 17/1/97 
// lex.h 
// lexing 'object' 

#include "my_const.h"


typedef enum {	LRB_TT, RRB_TT, INT_TT, SemiCol_TT,
				Separator_TT, Operator_TT, EndOfLine_TT, Identifier_TT,
				NULL_TT} TokenType_T;

#define LRB_C '('
#define RRB_C ')'
#define Plus_C '+'
#define Minus_C '-'
#define Mult_C '*'
#define Div_C '/'
#define SemiCol_C ';'
#define Space_C ' '
#define NewLine_C '\n'
#define Tab_C '\t'
#define EndOfStr_C '\0'
#define CarrRet_C '\r'
#define BackSpace_C '\b'
#define SingQuote_C '\''
#define DoubQuote_C '\"'
#define NULL_C '!'
#define UnderScore_C '_'
#define NL_C '\n'

// PRE TRUE 
// POST	CurrChar is the next newline
void
GoTo_NewLine();


// PRE TRUE 
// POST	CurrChar contains the first character on the next new line
//		and this was the last character from stdin
void
Start_NewLine();


// PRE TRUE
// POST	CurrChar the next character from stdin 
void
Start_Lex();


// PRE	-	TRUE 
// POST	-	IF there is a valid token on input THEN
//				token is read in
//				AND Get_TokenType returns its type
//				AND Q_LexOK() will return TRUE
void
Lex_Token();


// PRE	-	Q_LexOK() 
// POST	-	RETURNS type of last token 
TokenType_T
Get_TokenType();


// PRE	-	Q_LexOK() AND type of last token is character - e.g Operator_TT 
// POST	-	RETURNS value of last token 
char
Get_CharVal();


// PRE	-	Q_LexOK() AND type of last token is integer - e.g Operator_TT 
// POST	-	RETURNS value of last token 
int
Get_IntVal();


// PRE	-	Lex_Token() has been called 
// POST	-	IF a valid token was read THEN
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_LexOK();
