// stk_demo.cpp
// 8/8/98
// Demonstrates use of Stack_T with Element_T = StudentRec_T
// Ken Brownsey

#include <iostream.h>
#include "stack.h"

typedef Stack_T Stack_T;


// PRE	TRUE
// POST	IF Q_EmptyStack(Stack)
//				Message to say so
//			ELSE
//				Message to say not empty
void
Test_Empty(Stack_T Stack) {
	if (Q_EmptyStack(Stack)) {
		cout	<< "\nStack is empty\n";
	}
	else  {
		cout	<< "\nStack is not empty\n";
	}
}


// PRE	TRUE
// POST  IF NOT Q_Full(Stack) THEN
//				user is prompted for StudentRec
//				Stack' = Push(StudentRec, Stack)
//			ELSE appropriate message
void
Add_To_Stack(Stack_T Stack) {
	StudentRec_T	StudentRec;
	KAPRec_T			KAPRec;

	if (Q_FullStack(Stack)) {
		cout	<< "Stack is full";
	}
	else {
		cout	<< "Please type in new record\n";
		Read_Rec(StudentRec);
		KAPRec = Make_KAPRec(StudentRec);
		Push(KAPRec, Stack);
	}
}


// PRE	TRUE
// POST  IF NOT Q_EmptyStack(Stack) THEN
//				Stack' = Delete_Current(Stack)
//			ELSE appropriate message
void
Remove_Top(Stack_T Stack) {

	if (Q_EmptyStack(Stack)) {
		cout	<< "Stack is empty";
	}
	else {
		Pop(Stack);
	}
}


// PRE	TRUE
// POST  IF NOT Q_EmptyStack(Stack) THEN
//				current element is printed to screen
//			ELSE appropriate message
void
Print_Top(Stack_T Stack) {

	if (Q_EmptyStack(Stack)) {
		cout	<< "Stack is empty";
	}
	else {
		Write_Rec(Get_DataRec(Top(Stack)));
	}
}


// PRE	TRUE
// POST  all elements of Stack printed to screen
void
Show_All(Stack_T Stack) {
	Stack_T TempStack;
	KAPRec_T	KAPRec;


	if (Q_EmptyStack(Stack)) {
		cout	<< "Stack is empty";
	}
	else {
		TempStack = Create_Stack();
		cout	<< "\n";
		for(;! Q_EmptyStack(Stack);) {
			KAPRec = Top(Stack);
			Pop(Stack);
			Write_Rec(Get_DataRec(KAPRec));
			cout	<< "\n";
			Push(KAPRec, TempStack);
		}
		for(;! Q_EmptyStack(TempStack);) {
			KAPRec = Top(TempStack);
			Pop(TempStack);
			cout	<< "\n";
			Push(KAPRec, Stack);
		}
		Free_Stack(TempStack);
	}
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	test to see if stack is (e)mpty *********\n"
			<<	"***	(a)ppend a new record to stack **********\n"
			<<	"***	(r)emove top element       **************\n"
			<< "***	(p)rint top element          **************\n"
			<< "***	(s)how all elements          **************\n"
			<< "***  (m)enu						   **************\n";
}


// PRE	TRUE
// POST	Initialisation is done
void
Initialise(Stack_T *Stack_Ptr) {

	(*Stack_Ptr) = Create_Sequence();
	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(Stack_T Stack) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'e' :	Test_Empty(Stack);
				break;
			case 'a' :	Add_To_Stack(Stack);
				break;
			case 'r' :	Remove_Top(Stack);
				break;
			case 'p' :	Print_Top(Stack);
				break;
			case 's' :	Show_All(Stack);
				break;
			case 'm' : Menu();
				break;
			case 'x' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(Stack_T Stack) {
	for(;!Q_EmptyStack(Stack);) {
		Delete_Current(Stack);
	}
	Free_Stack(Stack);
	cout	<< "That is it !\n";
}


void
main() {
	Stack_T	Stack;

	Initialise(&Stack);
	Loop(Stack);
	Finalise(Stack);
}