// stack.cpp
// 7/8/98
// Stack_T based on Stack_T
// Ken Brownsey

#include "stack.h"
#include <stddef.h>

typedef struct Node_Tag {
	struct Node_Tag		*Next_Ptr;
	Element_T		Element;
} Node_T, *Node_Ptr_T;


typedef struct {
	Node_Ptr_T	Head,
					Current,
					BeforeCurrent;
}	StackRec_T, *StackRec_Ptr_T;


// PRE	TRUE
// POST	RETURNS an initialised Stack_T
Stack_T
Create_Stack() {
	StackRec_Ptr_T NewStack;

	NewStack = new StackRec_T;
	NewStack->Head = NULL;
	return((Stack_T) NewStack);
}


// PRE	NOT Q_FullStack(Stack)
// POST 	elements of Stack' = elements of Stack union {Element}
void
Push(Element_T NewElement, Stack_T Stack) {
	StackRec_Ptr_T 	NewStack;
	Node_Ptr_T     NewNode_Ptr;

	NewStack = (StackRec_Ptr_T) Stack;

	NewNode_Ptr = new Node_T;
	NewNode_Ptr->Element = NewElement;
	NewNode_Ptr->Next_Ptr = NewStack->Head;
	NewStack->Head = NewNode_Ptr;
}


// PRE	TRUE
// POST	IF Stack is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyStack(Stack_T Stack) {
		StackRec_Ptr_T SeerStack;

	SeerStack = (StackRec_Ptr_T) Stack;
	return(SeerStack->Head == NULL);
}


// PRE	TRUE
// POST	IF Stack is full
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_FullStack(Stack_T Stack) {
	return(FALSE);
}


// PRE	NOT Q_EmptyStack(Stack)
// POST	Stack' is Stack with the most recently entered
//			element removed
void
Pop(Stack_T Stack) {
	StackRec_Ptr_T SeerStack;
	Node_Ptr_T Temp;

	SeerStack = (StackRec_Ptr_T) Stack;
	Temp = SeerStack->Head;

	SeerStack->Head = SeerStack->Head->Next_Ptr;
	delete Temp;
}


// PRE	NOT Q_EmptyStack(Stack)
// POST	RETURNS the value of the most recently
//				entered element of Stack *)
Element_T
Top(Stack_T Stack) {
	StackRec_Ptr_T SeerStack;

	SeerStack = (StackRec_Ptr_T) Stack;
	return(SeerStack->Head->Element);
}



//	PRE	Q_EmptyStack(Stack)
//	POST	all memory allocated to Stack is freed up
// NOTES	Stack will need to be re-initialised
//			with Create_Stack() before being used again
void
Free_Stack(Stack_T Stack) {
	StackRec_Ptr_T SeerStack;

	SeerStack = (StackRec_Ptr_T) Stack;
	delete(SeerStack);
}
