// queue.cpp
// 7/8/98
// Queue_T based on Queue_T
// Ken Brownsey

#include "queue.h"
#include <stddef.h>

typedef struct Node_Tag {
	struct Node_Tag		*Next_Ptr;
	QueueElement		Element;
} Node_T, *Node_Ptr_T;


typedef struct {
	Node_Ptr_T	Head,
					Last;
}	QueueRec_T, *QueueRec_Ptr_T;


// PRE	TRUE
// POST	RETURNS an initialised Queue_T
Queue_T
Create_Queue() {
	QueueRec_Ptr_T Seer;

	Seer = new QueueRec_T;
	Seer->Head = NULL;
	Seer->Last = NULL;
	return((Queue_T) Seer);
}


// PRE	NOT Q_FullQueue(Queue)
// POST 	elements of Queue' = elements of Queue union {Element}
void
EnQueue(QueueElement NewElement, Queue_T Queue) {
	QueueRec_Ptr_T 	Seer;
	Node_Ptr_T     NewNode_Ptr;

	Seer = (QueueRec_Ptr_T) Queue;

	NewNode_Ptr = new Node_T;
	NewNode_Ptr->Element = NewElement;
	NewNode_Ptr->Next_Ptr = NULL;
	if (Seer->Head == NULL) {
		Seer->Head = NewNode_Ptr;
		Seer->Last = NewNode_Ptr;
	}
	else {
		Seer->Last->Next_Ptr = NewNode_Ptr;
		Seer->Last = NewNode_Ptr;
	}
}


// PRE	TRUE
// POST	IF Queue is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyQueue(Queue_T Queue) {
	QueueRec_Ptr_T SeerQueue;

	SeerQueue = (QueueRec_Ptr_T) Queue;
	return(SeerQueue->Head == NULL);
}



// PRE	NOT Q_EmptyQueue(Queue)
// POST	Queue' is Queue with the most recently entered
//			element removed
void
DeQueue(Queue_T Queue) {
	QueueRec_Ptr_T SeerQueue;
	Node_Ptr_T Temp;

	SeerQueue = (QueueRec_Ptr_T) Queue;
	Temp = SeerQueue->Head;
	SeerQueue->Head =	SeerQueue->Head->Next_Ptr;
	if (SeerQueue->Head == NULL) {
		SeerQueue->Last = NULL;
	}
	delete Temp;
}


// PRE	NOT Q_EmptyQueue(Queue)
// POST	RETURNS the value of the least recently
//				entered element of Queue *)
QueueElement
Front(Queue_T Queue) {
	QueueRec_Ptr_T SeerQueue;

	SeerQueue = (QueueRec_Ptr_T) Queue;
	return(SeerQueue->Head->Element);
}



//	PRE	Q_EmptyQueue(Queue)
//	POST	all memory allocated to Queue is freed up
// NOTES	Queue will need to be re-initialised
//			with Create_Queue() before being used again
void
Free_Queue(Queue_T Queue) {
	QueueRec_Ptr_T SeerQueue;

	SeerQueue = (QueueRec_Ptr_T) Queue;
	delete(SeerQueue);
}
