#include <iostream.h>
#include <stdlib.h>
#include "my_const.h"

typedef int *IntArray_T;
typedef enum {Left, Right} Move_T;
typedef enum {Stop, Go} StopGo_T;
typedef Move_T	*MoveArray_T;
typedef StopGo_T	*StopGoArray_T;


int its = 0;

void
Print_Out_Array(IntArray_T IntArray, int Size) {
	int	Index;

	for(Index = 0; Index < Size; Index++) {
		cout	<< IntArray[Index];
		if (IntArray[Index] > 9) {
			cout	<< " ";
		}
		else {
			cout << "  ";
		}
	}
}


void
Set_Up_Array(IntArray_T &IntArray, int Size) {
	int	Index;

	IntArray = new int[Size];

	for(Index = 0; Index < Size; Index++) {
		IntArray[Index] = Size - 1 - Index;
	}
	Print_Out_Array(IntArray, Size);
	cout	<< "\n";
}





IntArray_T
Copy_Array(IntArray_T Ints, int Size) {
	int	Index;
	IntArray_T	Copy;

	Copy = new int[Size];

	for(Index = 0; Index < Size; Index++) {
		Copy[Index] = Ints[Index];
	}
	return(Copy);
}


BOOLEAN
Q_EqualArrays(IntArray_T Ints1, IntArray_T Ints2, int Size) {
	int	Index;
	BOOLEAN	Q_Eq;

	Q_Eq = TRUE;

	for(Index = 0; (Index < Size) && Q_Eq ; Index++) {
		if (Ints1[Index] != Ints2[Index]) {
			Q_Eq = FALSE;
		}
	}
	return(Q_Eq);
}


void
Swap(int &Int1, int &Int2) {
	int Temp;

	Temp = Int1;
	Int1 = Int2;
	Int2 = Temp;
}


void
New_Array(IntArray_T &IntArray, int &Size) {

	cout	<< "\nPlease type in size of array ==> ";
	cin	>>	Size;
	Set_Up_Array(IntArray, Size);
}


void
Test_Equal() {
	IntArray_T	Ints1,
					Ints2;
	int	Size,
			Pos1,
			Pos2;

	cout	<< "\nPlease type in size of array ==> ";
	cin	>>	Size;
	Set_Up_Array(Ints1, Size);
	Set_Up_Array(Ints2, Size);
	if (Q_EqualArrays(Ints1, Ints2, Size)) {
		cout	<< "\nArrays equal\n";
		Print_Out_Array(Ints1, Size);
		cout	<< "\n";
		Print_Out_Array(Ints2, Size);
		cout	<< "\n";
	}
	else {
		cout	<< "\nArrays not equal\n";
		Print_Out_Array(Ints1, Size);
		cout	<< "\n";
		Print_Out_Array(Ints2, Size);
		cout	<< "\n";
	}
	Pos1 = rand() % Size;
	Pos2 = rand() % Size;
	cout 	<< "\n"
			<< Pos1
			<< " "
			<< Pos2
			<< "\n";
	Swap(Ints1[Pos1], Ints1[Pos2]);
	if (Q_EqualArrays(Ints1, Ints2, Size)) {
		cout	<< "\nArrays equal\n";
		Print_Out_Array(Ints1, Size);
		cout	<< "\n";
		Print_Out_Array(Ints2, Size);
		cout	<< "\n";
	}
	else {
		cout	<< "\nArrays not equal\n";
		Print_Out_Array(Ints1, Size);
		cout	<< "\n";
		Print_Out_Array(Ints2, Size);
		cout	<< "\n";
	}
}

int
Find_Mover(StopGoArray_T SGModes, int Size) {
	int	Index;
	BOOLEAN	Q_Found;

	Q_Found = FALSE;
	for(Index = Size - 1; (Index > 0) && !Q_Found; Index--) {
		if (SGModes[Index] == Go) {
			Q_Found = TRUE;
		}
	}
	Index++;
	return(Index);
}


int
Find_Position(IntArray_T Ints, int Int, int Size) {
	int	Index;
	BOOLEAN	Q_Found;

	Q_Found = FALSE;
	for(Index = 0; (Index < Size) && !Q_Found; Index++) {
		if (Ints[Index] == Int) {
			Q_Found = TRUE;
		}
	}
	Index--;
	return(Index);
}



void
Iterate(	IntArray_T &Ints,
			StopGoArray_T &SGModes,
			MoveArray_T	&Moves,
			int Size) {
	int 	Mover;
	Move_T	Move;
	int	Position;
	int	Index;


	Mover = Find_Mover(SGModes, Size);
cout << Mover << "  its " << its << "\n"; its++;
	Move = Moves[Mover];
	Position = Find_Position(Ints, Mover, Size);
	if (Move == Right) {
		Swap(Ints[Position], Ints[Position + 1]);
		Position = Position + 1;
		if (Position == Size - 1) {
			Moves[Mover] = Left;
			SGModes[Mover] = Stop;
		}
		else {
			if (	(SGModes[Ints[Position + 1]] == Stop) &&
					(Mover < Ints[Position + 1])) {
				Moves[Mover] = Left;
				SGModes[Mover] = Stop;
			}
		}
	}
	else {
	// Move == Left
		Swap(Ints[Position], Ints[Position - 1]);
		Position = Position - 1;
		if (Position == 0) {
			Moves[Mover] = Right;
			SGModes[Mover] = Stop;
		}
		else {
			if (	(SGModes[Ints[Position - 1]] == Stop) &&
					(Mover < Ints[Position - 1])) {
				Moves[Mover] = Right;
				SGModes[Mover] = Stop;
			}
		}
	}
	for (Index = Mover + 1; Index < Size; Index ++) {
		SGModes[Index] = Go;
	}
}


void
Perms(IntArray_T &Ints, int Size) {
	IntArray_T	Start;
	int	Index;
	MoveArray_T	Moves;
	StopGoArray_T	SGModes;

	its = 0;

	Moves = new Move_T[Size];
	SGModes = new StopGo_T[Size];

	for(Index = 1; Index < Size; Index++) {
		Moves[Index] = Right;
		SGModes[Index] = Go;
	}

	Start = Copy_Array(Ints, Size);
	Print_Out_Array(Start, Size);
	cout	<< "\n";

	Iterate(Ints, SGModes, Moves, Size);
	Print_Out_Array(Ints, Size);
	cout	<< "\n";

	for (;!Q_EqualArrays(Ints, Start, Size);) {
		Iterate(Ints, SGModes, Moves, Size);
		Print_Out_Array(Ints, Size);
		cout	<< "\n";
	}
}

// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	(s)et up array *********\n"
			<<	"***	(p)rint out array ******\n"
			<<	"***	test (e)qual  **********\n"
			<<	"***	(f)ind all perms********\n"
			<< "***  e(x)it    **************\n"
			<< "***  (m)enu	 **************\n";
}


// PRE	TRUE
// POST	Initialisation is done
void
Initialise() {
	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop() {

	char	Request;
	int	RequestCount;
	IntArray_T IntArray;
	int	Size;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 's' :	New_Array(IntArray, Size);
				break;
			case 'p' :	Print_Out_Array(IntArray, Size);
				break;
			case 'e' :	Test_Equal();
				break;
			case 'f' :	Perms(IntArray, Size);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise() {
	cout	<< "That is it !\n";
}


void
main() {
	Initialise();
	Loop();
	Finalise();
}
