// fibo.cpp
// 29/8/98
// Demonstrates the Fibonacci function
// Ken Brownsey

#include <iostream.h>



// PRE	n >= 0
// POST	RETURNS the nth Fibonacci number
int
Fibo_R(int n) {
	if ((n == 0) || (n == 1)) {
		return(1);
	}
	else {
		return(Fibo_R(n - 1) + Fibo_R(n - 2));
	}
}


// PRE	n >= 0
// POST	RETURNS n!
int
I_Fibo(int n) {
	int	Index;
	int	FibMinus2,
			FibMinus1,
			Fib,
			Hold;

	if ((n == 0) || (n == 1)) {
		Fib = 1;
	}
	else {
		FibMinus2 = 1;
		FibMinus1 = 1;

		for(Index = 2; Index <= n; Index++) {
			 Fib = FibMinus1 + FibMinus2;
			 // Set up previous two values for next time round
			 FibMinus2 = FibMinus1;
			 FibMinus1 = Fib;
		}
	}
	return(Fib);
}


// PRE	n >= 0
// POST	RETURNS the nth Fibonacci number
//       outputs the details of the call being made
//			Count is the number of times that Fibo_R is called
int
FiboCount_R(int n, int &Count) {
	cout	<< "Calling FiboCount_R("
			<< n
			<< ", "
			<< Count
			<< ")\n";
	Count++;
	if ((n == 0) || (n == 1)) {
		return(1);
	}
	else {
		return(FiboCount_R(n - 1, Count) + FiboCount_R(n - 2, Count));
	}
}


// PRE	n >= 0
// POST	RETURNS number of calls that would be made to Fib_R(n)
int
Count_FibCalls_R(int n) {
	if ((n == 0) || (n == 1)) {
		return(1);
	}
	else {
		return(1 + Count_FibCalls_R(n - 1) + Count_FibCalls_R(n - 2));
	}
}


// PRE	TRUE
// POST	Prompts for non-negative integer
//			AND 	IF input is not negative
//             	RETURNS factorial of input
void
Do_RecursiveFibo() {
	int	Val;

	cout	<< "\nPlease type in a non-negative integer";
	cout	<< "\n==> ";
	cin	>> Val;
	if (Val >= 0) {
		cout	<< "\n\nFibonacci("
				<< Val
				<< ") is "
				<< Fibo_R(Val)
				<< "\n\n";
	}
	else {
		cout	<< "\nNeed number >= 0";
	}
}


// PRE	TRUE
// POST	Prompts for non-negative integer
//			AND 	IF input is not negative
//             	RETURNS factorial of input
void
Do_IterativeFibo() {
	int Val;

	cout	<< "\nPlease type in a non-negative integer";
	cout	<< "\n==> ";
	cin	>> Val;
	if (Val >= 0) {
		cout	<< "\n\nFibonacci("
				<< Val
				<< ") is "
				<< I_Fibo(Val)
				<< "\n\n";
	}
	else {
		cout	<< "\nNeed number >= 0";
	}
}


// PRE	TRUE
// POST	Prompts for non-negative integer
//			AND 	IF input is not negative
//             	RETURNS factorial of input
//						showing steps in recurisve evaluation
void
Count_FibCalls1() {
	int	Val;
	int	Count;
	int	Fib;

	cout	<< "\nPlease type in a non-negative integer";
	cout	<< "\n==> ";
	cin	>> Val;
	if (Val >= 0) {
		Count = 0;
		Fib = FiboCount_R(Val, Count);
		cout	<< "\n\nTo evaluate Fibonacci recursively "
				<< Val
				<< " we need to make "
				<< Count
				<< " calls\n\n"
				<< "\n\nFibonacci("
				<< Val
				<< ") is "
				<< Fib
				<< "\n\n";
	}
	else {
		cout	<< "\nNeed number >= 0";
	}
}


// PRE	TRUE
// POST	Prompts for non-negative integer
//			AND 	IF input is not negative
//             	RETURNS factorial of input
//						showing steps in recurisve evaluation
void
Count_FibCalls2() {
	int	Val;

	cout	<< "\nPlease type in a non-negative integer";
	cout	<< "\n==> ";
	cin	>> Val;
	if (Val >= 0) {
		cout	<< "\n\nTo evaluate Fibonacci recursively "
				<< Val
				<< " we need to make "
				<< Count_FibCalls_R(Val)
				<< " calls \n\n"
				<< "\n\nFibonacci("
				<< Val
				<< ") is "
				<< Fibo_R(Val)
				<< "\n\n";
	}
	else {
		cout	<< "\nNeed number >= 0";
	}
}


// PRE	TRUE
// POST	Message about program printed to screen
void
Initialise() {
	cout	<< "\nThe Magnificent Factorial Program\n\n";
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	(r)ecursive Fibonacci       	**************\n"
			<< "***	(i)terative Fibonacci		  	**************\n"
			<<	"***	(c)ount calls to recursive Fibonacci *******\n"
			<<	"***	(o)ther count calls to recursive Fibonacci *\n"
			<< "***  (m)enu						   	**************\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop() {

	char	Request;
	int	RequestCount;


	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'r' :	Do_RecursiveFibo();
				break;
			case 'i' :	Do_IterativeFibo();
				break;
			case 'c' :	Count_FibCalls1();
				break;
			case 'o' :	Count_FibCalls2();
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Announces departure
void
Finalise() {
	cout	<< "That is it !\n";
}


void
main() {
	Initialise();
	Loop();
	Finalise();
}
