// s_hanoi.cpp
// 16/8/98
// Simple demonstration of recursion in Hanoi problem solving
//	with Disc_T = int
// Ken Brownsey

#include <iostream.h>

typedef enum Peg_T {A, B, C};
typedef int Disc_T;

// PRE	TRUE
// POST	RETURNS character for peg is written to screen
char
Char_For_Peg(Peg_T Peg) {
	return((char)(int('A') + Peg));
}


// PRE 	TRUE
// POST  Top disc moved from FromPeg to ToPeg
//			AND message written to screen
void
Move_Disc(Disc_T Disc, Peg_T FromPeg, Peg_T ToPeg) {

	cout	<< "\nMoving disc "
			<< Disc
			<< " from "
			<< Char_For_Peg(FromPeg)
			<< " to peg "
			<< Char_For_Peg(ToPeg);
}


// PRE	TRUE
//	POST	Solution to Hanoi problem shown on screen with moves and peg states
void
Move_Tower_R(int NumDiscs, Peg_T From, Peg_T Via, Peg_T To) {
	if (NumDiscs > 0) {
		Move_Tower_R(NumDiscs - 1, From, To, Via);
		Move_Disc(NumDiscs, From, To);
		Move_Tower_R(NumDiscs - 1, Via, From, To);
	}
}

// PRE	TRUE
// POST  Prompts for number of discs in Hanoi problem
//			AND shows Hanoi solution
void
Do_Hanoi() {
	int NumDiscs;

	cout	<< "\nHow many discs ==> ";
	cin	>> NumDiscs;

	Move_Tower_R(NumDiscs, A, B, C);
	cout	<< "\n";
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	(s)olve Hanoi        **************\n"
			<< "***  (m)enu						  *********\n"
			<< "***  e(x)it						  *********\n";
}


// PRE	TRUE
// POST	Initialisation is done
void
Initialise() {

	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop() {

	char	Request;
	int	RequestCount;
	int	NumDiscs;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 's' :	Do_Hanoi();
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise() {
	cout	<< "That is it !\n";
}


void
main() {
	Initialise();
	Loop();
	Finalise();
}