// rec_util.cpp
// 23/8/98
// Recursive procedures on Stack_T
// Ken Brownsey

#include "rec_util.h"

// PRE	TRUE
// POST	Stack printed out in order of recentness
void
Print_Stack_R(Stack_T Stack) {
	Element_T NextEl;

	if (!Q_EmptyStack(Stack)) {
		NextEl = Top(Stack);
		Write_Rec(NextEl);
		cout	<< " ";
		Pop(Stack);
		Print_Stack_R(Stack);
		Push(NextEl, Stack);
	}
}


// PRE	TRUE
// POST	RETURNS copy of Stack
Stack_T
Copy_Stack_R(Stack_T Stack) {
	Element_T NextEl;
	Stack_T Result;

	if (!Q_EmptyStack(Stack)) {
		NextEl = Top(Stack);
		Pop(Stack);
		Result = Copy_Stack_R(Stack);
		Push(NextEl, Result);
		Push(NextEl, Stack);
	}
	else {
		Result = Create_Stack();
	}
	return(Result);
}


// PRE	TRUE
// POST	Q_EmptyStack(Stack)
void
Make_Empty_R(Stack_T Stack) {

	if (!Q_EmptyStack(Stack)) {
		Pop(Stack);
		Make_Empty_R(Stack);
	}
}


// PRE	TRUE
// POST	IF Element is in Stack
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_Member_R(Element_T Element, Stack_T Stack) {
	Element_T TopEl;

	if (Q_EmptyStack(Stack)) {
		return(FALSE);
	}
	else {
		TopEl = Top(Stack);
		if (Element == TopEl) {
			return(TRUE);
		}
		else {
			Pop(Stack);
			if (Q_Member_R(Element, Stack)) {
				Push(TopEl, Stack);
				return(TRUE);
			}
			else {
				Push(TopEl, Stack);
				return(FALSE);
			}
		}
	}
}


// PRE	TRUE
// POST	IF Q_Member_R(El, Stack)
//				Stack' = Stack with first occurrence of El removed
//			ELSE
//				Stack' = Stack
void
Delete_R(Element_T El, Stack_T Stack) {
	Element_T TopEl;

	if (!Q_EmptyStack(Stack)) {
		TopEl = Top(Stack);
		Pop(Stack);
		if (El != TopEl) {
			Delete_R(El, Stack);
			Push(TopEl, Stack);
		}
	}
}



// PRE	TRUE
// POST	RETURNS stack containing all members of
//				Stack1 that are not in Stack2
//				IF e occurs n times in Stack1 and
//					m times in Stack2, and n > m
//						e occurs n - m times in RETURNED stack
//			Stack2 will, in general, be altered
Stack_T
Complement_R(Stack_T Stack1, Stack_T Stack2) {
	Element_T TopEl;
	Stack_T	Result;

	if (Q_EmptyStack(Stack1)) {
		return(Create_Stack());
	}
	else {
		TopEl = Top(Stack1);
		Pop(Stack1);
		if (Q_Member_R(TopEl, Stack2)) {
			Delete_R(TopEl, Stack2);
			Result = Complement_R(Stack1, Stack2);
		}
		else {
			Result = Complement_R(Stack1, Stack2);
         Push(TopEl, Result);
		}
		Push(TopEl, Stack1);
	}
	return(Result);
}



