// Ken Brownsey
// 31/8/98
// bst_util.h
// BST_T utilities
#include "bst_tree.h"


typedef int Path_T;
typedef int Depth_T;


// PRE	TRUE
// POST	BST is printed inorder
void
Print_Tree_R(BST_T BST);


// PRE	TRUE
// POST	Elements of BST are printed inorder
void
InOrder_R(BST_T BST);


// PRE	TRUE
// POST	Elements of BST are printed preorder
void
PreOrder_R(BST_T BST);


// PRE	TRUE
// POST	Elements of BST are printed postorder
void
PostOrder_R(BST_T BST);


// PRE	TRUE
// POST	User is prompted for filename
//			IF this is a file of Element_T's
//				these are loaded into DBase
void
Load_Tree_From_File(BST_T &BST);


// PRE TRUE
// POST RETURNS size of BST
int
Size_R(BST_T BST);

// PRE	NOT Q_Empty(BST)
// POST	RETURNS sum of elements in BST
Key_T
Sum_R(BST_T BST);


// PRE	TRUE
// POST	all records in BST equal to Rec are printed
void
Print_All_Equal_R(BST_T BST, Element_T Rec);


// PRE	TRUE
// POST	User is prompted for Path and Length
//			IF Path >= 0 AND Length > 0 AND Path < 2^Length
//				path represented by Path and Length
//				is printed out
void
Show_Path();


// PRE	TRUE
// POST	RETURNS depth of Tree
Depth_T
Find_Depth_R(BT_T Tree);


// PRE	Path >= 0, Depth >= 1
// POST	Prints out keys of Tree sideways at Depth
// 		where Depth - 1 is
//			number of levels of Tree from root
void
Tree_Diagram_R(BST_T Tree, Path_T Path, Depth_T Depth);


