// Ken Brownsey
// 31/8/98
// bst_tree.cpp
// BST_T

#include "bst_tree.h"

// PRE	TRUE
// POST	if record with key Key is in BST
//				returnS TRUE
//			ELSE
//				returnS FALSE
BOOLEAN
Q_BST_Present_R(Key_T Key, BST_T BST) {
	if (Q_EmptyTree(BST)) {
		return(FALSE);
	}
	else {
		if (Key < Get_Key(Get_Root(BST))) {
			return(Q_BST_Present_R(Key, Get_Left(BST)));
		}
		else {
			if (Key > Get_Key(Get_Root(BST))) {
				return(Q_BST_Present_R(Key, Get_Right(BST)));
			}
			else {
				return(TRUE);
			}
		}
	}
}


// PRE	NOT Q_BST_Present_R(Rec, BST)
// POST	returnS BST with Rec inserted
BST_T
BST_Insert_R(Element_T Rec, BST_T BST) {
	if (Q_EmptyTree(BST)) {
		return(Make_Tree(Create_Tree(), Rec, Create_Tree()));
	}
	else {
		if (Get_Key(Rec) < Get_Key(Get_Root(BST))) {
			return(Make_Tree(	BST_Insert_R(Rec, Get_Left(BST)),
						Get_Root(BST),
						Get_Right(BST)));
		}
		else {
			return(Make_Tree(	Get_Left(BST),
								Get_Root(BST),
								BST_Insert_R(Rec, Get_Right(BST))));
		}
	}
}


// PRE	Q_BST_Present_R(Key, BST)
// POST	returnS record with key value Key from BST
Element_T
BST_Retrieve_R(Key_T Key, BST_T BST) {

	if (Key < Get_Key(Get_Root(BST))) {
		return(BST_Retrieve_R(Key, Get_Left(BST)));
	}
	else {
		if (Key > Get_Key(Get_Root(BST))) {
			return(BST_Retrieve_R(Key, Get_Right(BST)));
		}
		else {
			return(Get_Root(BST));
		}
	}
}


// PRE	NOT Q_EmptyTree(BST)
// POST	returnS rightmost Element_T of BST
Element_T
Get_RightMost_R(BST_T BST) {

	if (Q_EmptyTree(Get_Right(BST))) {
		return(Get_Root(BST));
	}
	else {
		return(Get_RightMost_R(Get_Right(BST)));
	}
}


// PRE	TRUE
// POST	if (Q_BST_Present(Rec, BST)
//				returnS BST with Rec deleted
//			ELSE
//				returnS BST
BST_T
BST_Delete_R(Key_T Key, BST_T BST) {
	Element_T NewRoot;

	if (Q_EmptyTree(BST)) {
		return(BST);
	}

	if (Key < Get_Key(Get_Root(BST))) {
		return(Make_Tree(	BST_Delete_R(Key, Get_Left(BST)),
								Get_Root(BST),
								Get_Right(BST)));
	}

	if (Key > Get_Key(Get_Root(BST))) {
		return(Make_Tree(	Get_Left(BST),
								Get_Root(BST),
								BST_Delete_R(Key, Get_Right(BST))));
	}

	if (Q_EmptyTree(Get_Left(BST))) {
		return(Get_Right(BST));
	}

	if (Q_EmptyTree(Get_Right(BST))) {
		return(Get_Left(BST));
	}

	NewRoot = Get_RightMost_R(Get_Left(BST));

	return(Make_Tree(	BST_Delete_R(	Get_Key(NewRoot),
										Get_Left(BST)),
						NewRoot,
						Get_Right(BST)));
}


