// Ken Brownsey
// 31/8/98
// rec_tree.h
// Generic structural ADT recursive tree
// A binary tree is either the empty tree
// or an element, the root, and two binary trees
// the left sub tree and the right sub tree

#include "data.h"
#include "my_const.h"

typedef DataRec_T Element_T;

typedef void  *BT_T;

// PRE	TRUE
// POST	RETURNS the empty tree
BT_T
Create_Tree();


// PRE	TRUE
// POST	IF Tree is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyTree(BT_T Tree);


// PRE	Tree is not empty
// POST	RETURNS the record in the root
Element_T
Get_Root(BT_T Tree);


// PRE	TRUE
// POST	IF Tree is not empty
//				RETURNS the left sub tree of Tree
//			ELSE
//				RETURNS the empty tree
BT_T
Get_Left(BT_T Tree);



// PRE	TRUE
// POST	IF Tree is not empty
//				RETURNS the right sub tree of Tree
//			ELSE
//				RETURNS the empty tree
BT_T
Get_Right(BT_T Tree);


// PRE	TRUE
// POST	RETURNS the tree whose head is Root and tail is Tree
BT_T
Make_Tree(BT_T Left, Element_T Element, BT_T Right);


// PRE  - 	TRUE
// POST - 	RETURNS the number of nodes allocated
int
Get_NumberNodes_Allocated();