// Ken Brownsey
// 31/8/98
// iterator.h
// iterator for BST

#include "bst_util.h"

#ifndef ITERATOR_H
#define ITERATOR_H

typedef void *BST_Iterator_T;

// PRE	TRUE
// POST	Iterator is created
BST_Iterator_T
Create_Iterator();

// PRE	Create_Iterator(Iterator) has been called
//			AND since last, if any, call to
//			Destroy_Iterator(Iterator)
// POST	Iterator is destroyed
void
Destroy_Iterator(BST_Iterator_T Iterator);

// PRE	TRUE
// POST	IF Start_Iteration(Iterator, BST) has been executed
//				correctly for some value BST
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
Q_Bound_To_BST(BST_Iterator_T Iterator);


// PRE	Q_Bound_To_BST(Iterator)
// POST	IF iteration is at ordinally keyed first node
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_StartOfIteration(BST_Iterator_T Iterator);


// PRE	Q_Bound_To_BST(Iterator)
// POST	IF iteration is at ordinally keyed last node
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EndOfIteration(BST_Iterator_T Iterator);

// PRE	NOT Q_EmptyTree(BST)
// POST	Q_StartOfIteration(Iterator')
void
Start_Iteration(BST_Iterator_T &Iterator, BST_T BST);


// PRE	Start_Iteration(&Iterator, BST) has been called
//			for some value BST
//			AND NOT Q_EndOfIteration(Iterator)
// POST	NOT Q_Iteration_Reset(Iterator') AND
//					current is next node in iteration
void
Iterate(BST_Iterator_T &Iterator);


// PRE     Q_Iteration_Started(Iterator)
// RETURNS current record in iteration
Element_T
Get_Current(BST_Iterator_T Iterator);


// PRE	Q_Iteration_Started(Iterator)
// POST	RETURNS number of current record in iteration
int
Get_CurrentNumber(BST_Iterator_T Iterator);


// PRE	TRUE
// POST	Iterator stack printed out in order of recentness
// NOTES This procedure is required only for demonstration purposes
// to view state of iterator stack
void
Print_IteratorStackKeys(BST_Iterator_T Iterator);

#endif
