// treedemo.cpp
// 31/8/98
// Demonstrates binary search tree
// Ken Brownsey

#include "iterator.h"
#include <iostream.h>

#define ReqSize	20


// Global list
BST_T		DataBase;

// PRE	TRUE
// POST	user is prompted for record
//			if (record is not in DBase
//				it is added to DBase
//			} else
//				appropriate message
void
Add_New_Record(BST_T &DBase) {

	Element_T	DataRec;

	cout	<< "\nType record in\n";
	Read_Rec(DataRec);
	if (!Q_BST_Present_R(Get_Key(DataRec), DBase)) {
		BST_Insert(DataRec, DBase);
	}
	else {
		cout	<<	"\nRecord with key ";
		Write_Key(Get_Key(DataRec));
		cout	<< " is already in database\n";
	}
}


// PRE	TRUE
// POST	user is prompted for key value
//			if (record with that key is in DBase
//				message to say so
//			} else
//				message to say not
void
Check_Key_Present(BST_T DBase) {

	Key_T	Key;

	cout	<< "\nType key to be checked for ==> ";
	Key = Read_Key();
	if (Q_BST_Present_R(Key, DBase)) {
		cout	<<	"\nKey value ";
		Write_Key(Key);
		cout	<<	" is present in the database\n";
	}
	else {
		cout	<<	"\nKey value ";
		Write_Key(Key);
		cout	<<	" is not present in the database\n";
	}
}


// PRE	TRUE
// POST	if (!Q_EmptyTree(DBase)
//				user is prompted for key value
//				if (record with that key is in DBase
//					record is printed to screen
//				} else
//					message to say record not present
//			} else
//				message to say DBase is empty
void
Get_Record(BST_T DBase) {

	Key_T	Key;

	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nType key of record to be retrieved ==> ";
		Key = Read_Key();
		if (Q_BST_Present_R(Key, DBase)) {
			cout	<<	"\nRecord is \n ";
			Write_Rec(BST_Retrieve_R(Key, DBase));
			cout	<<	"\n";
		}
		else {
			cout	<<	"\nKey value ";
			Write_Key(Key);
			cout	<<	" is not present in the database\n";
		}
	}
	else {
		cout	<<	"\nDatabase is empty\n\n";
	}
}


// PRE	TRUE
// POST	if (!Q_EmptyTree(DBase)
//				user is prompted for key value
//				if (record with that key is in DBase
//					record is printed to screen
//				} else
//					message to say record not present
//			} else
//				message to say DBase is empty
void
Erase_Record(BST_T &DBase) {

	Key_T	Key;

	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nType key of record to be erased ==> ";
		Key = Read_Key();
		if (Q_BST_Present_R(Key, DBase)) {
			BST_Delete_R(Key, DBase);
		}
		else {
			cout	<<	"\nKey value ";
			Write_Key(Key);
			cout	<<	" is not present in the database\n";
		}
	}
	else {
		cout	<<	"\nDatabase is empty\n\n";
	}
}


// PRE	TRUE
// POST	if (DataBase is not empty
//				it is printed in key order
void
Print_DataBase(BST_T DataBase) {

	if (Q_EmptyTree(DataBase)) {
		cout	<< "\n No records to print \n";
	}
	else {
		Print_Tree_R(DataBase);
	}
}


// PRE	TRUE
// POST	if (DBase is not empty
//				Tree diagram of DBase printed
//			} else
//				Appropriate message
void
Show_DBase_Structure(BST_T DBase) {

	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nStructure of database is \n";
		Tree_Diagram_R(DBase, 0, 1);
	}
	else {
		cout	<< "\n\nNo elements in database";
	}
}


// PRE	TRUE
// POST if (!Q_EmptyTree) {
//			prints out size of tree
//		} else
//			empty tree message
void
Print_Size(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nSize is "
				<< Size_R(DBase)
				<< "\n";
	}
	else {
		cout	<< "\Database is empty\n";
	}
}


// PRE	TRUE
// POST if (!Q_EmptyTree) {
//			prints out sum of elements in tree
//		} else
//			empty tree message
void
Print_Sum(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nSum of keys of elements is \n";
		Write_Key(Sum_R(DBase));
	}
	else {
		cout	<< "\Database is empty\n";
	}
}


// PRE	TRUE
// POST	Prints height of database tree to screen
void
Print_Height(BST_T DBase) {

	cout	<< "\nHeight of database is "
			<< Find_Depth_R(DBase)
			<< "\n";
}



// PRE	TRUE
// POST	if (DBase is not empty
//				prints out elements inorderwise
//			} else
//				appropriate message
void
Do_InOrder(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		InOrder_R(DBase);
	}
	else {
		cout	<< "\nDatabase is empty\n";
	}
}


// PRE	TRUE
// POST	if (DBase is not empty
//				prints out elements preorderwise
//			} else
//				appropriate message
void
Do_PreOrder(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		PreOrder_R(DBase);
	}
	else {
		cout	<< "\nDatabase is empty\n";
	}
}


// PRE	TRUE
// POST	if (DBase is not empty
//				prints out elements postorderwise
//			} else
//				appropriate message
void
Do_PostOrder(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		PostOrder_R(DBase);
	}
	else {
		cout	<< "\nDatabase is empty\n";
	}
}


// PRE	TRUE
// POST	traversal menu displayed
void
Traversal_Menu() {

	cout	<< "***   Traversal Options  	  *****************\n";
	cout	<< "***   (i)norder traversal  	  **************\n";
	cout	<< "***   p(r)int all records with brackets *****\n";
	cout	<< "***   (t)raversal menu 	  *****************\n";
	cout	<< "***   e(x)it to main menu	  	****************\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		for traversal options
//		until 'x' is the character read
void
Traversals(BST_T DBase) {

	char 	Request;
	static int	RequestCount = 0;

	for (Request = 'm'; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'i' : Do_InOrder(DBase);
				break;
			case 'e' : Do_PreOrder(DBase);
				break;
			case 'o' : Do_PostOrder(DBase);
				break;
			case 'r' : Print_DataBase(DBase);
				break;
			case 'm' : Traversal_Menu();
				break;
			default   : cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext traversal request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;

	}
}


// PRE	TRUE
// POST	if NOT Q_EmptyTree(DBase)
//				Start_Iteration(Iterator, DBase)
//			else
//				appropriate message
void
Start_Iterate(BST_Iterator_T Iterator, BST_T DBase) {

	if (!Q_EmptyTree(DBase)) {
		Start_Iteration(Iterator, DBase);
	}
	else {
		cout << "\nDatabase is empty\n";
	}
}


// PRE	TRUE
// POST	if (Q_Bound_To_BST(Iterator)
//				if (!Q_EndOfIteration(Iterator)
//					current of Iterator is one after
//					that of Iterator
//				else
//					appropriate message
//			else
//				appropriate message
void
Do_Iterate(BST_Iterator_T Iterator) {

	if (Q_Bound_To_BST(Iterator)) {
		if (!Q_EndOfIteration(Iterator)) {
			Iterate(Iterator);
		}
		else {
			cout << "\nAt end of iteration";
		}
	}
	else {
		cout	<< "\nIterator not bound";
	}
}


// PRE 	TRUE
// POST	if (!Q_EmptyTree(DBase)) {
//				if (Q_Iteration_Started(Iterator)) {
//					current of Iterator is printed
//				} else
//					appropriate message
//			} else
//				appropriate message
void Print_Current(BST_Iterator_T Iterator) {

	if (Q_Bound_To_BST(Iterator)) {
		cout  <<	"\nRecord number "
				<<	Get_CurrentNumber(Iterator)
				<< " is ";
		Write_Rec(Get_Current(Iterator));
		cout	<< "\n";
	}
	else {
		cout	<< "\nIterator not bound\n";
	}
}


// PRE	TRUE
// POST	traversal menu displayed
void
Iterate_Menu() {
	cout	<<	"***   Iteration Options  	  *****************\n"
			<< "***   (r)eset iteration  	  *****************\n"
			<< "***   (i)terate		  	  ********************\n"
			<< "***   (p)rint current record ****************\n"
			<< "***   print iterator (s)tack ****************\n"
			<< "***   show (d)iagram of database  ***********\n"
			<< "***   (m)enu 	  *****************************\n"
			<< "***   e(x)it to main menu	  	****************\n";
}



// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		for iterate options
//		until 'x' is the character read
void
Iterating(BST_T DBase) {
	char	Request;
	int	RequestCount;
	BST_Iterator_T 	Iterator;

	RequestCount = 0;
	Request = 'm';
	Iterator = Create_Iterator();
	for (;Request != 'x';) {

		switch(Request) {

			case	'r' : Start_Iterate(Iterator, DBase);
				break;
			case	'i' : Do_Iterate(Iterator);
				break;
			case	'p' : Print_Current(Iterator);
				break;
			case	's' :	Print_IteratorStackKeys(Iterator);
				break;
			case	'd' : Show_DBase_Structure(DBase);
				break;
			case	'm' : Iterate_Menu();
				break;
			default   : cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext iteration request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
   Destroy_Iterator(Iterator);
}

// PRE	TRUE
// POST	menu displayed
void
Menu() {

	cout	<< "***   Main Menu            	  **************\n";
	cout	<< "***   (a)dd a new record  	  **************\n";
	cout	<< "***   check (k)ey present  	  **************\n";
	cout	<< "***   (g)et record         	  **************\n";
	cout	<< "***   (e)rase record       	  **************\n";
	cout	<< "***   print (s)ize of database **************\n";
	cout	<< "***   print s(u)m of keys in database      **\n";
	cout	<< "***   show (d)iagram of database  ***********\n";
	cout	<< "***   print (h)eight of database  ***********\n";
	cout	<< "***   show LR path for (p)ath and length  ***\n";
	cout	<< "***   (l)oad database from file  ************\n";
	cout	<< "***   sa(v)e database to file  ************\n";
	cout	<< "***   (t)raversal options  ******************\n";
	cout	<< "***   (i)terate options  ******************\n";
	cout	<< "***   (r)eset database **********************\n";
	cout	<< "***   this (m)enu	       	****************\n";
	cout	<< "***   e(x)it			        	****************\n";
}


// PRE	TRUE
// POST	DBase initialised
void
Initialise(BST_T &DBase) {

	DBase = Create_Tree();
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(BST_T DBase) {

	char 	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'a': Add_New_Record(DBase);
				break;
			case 'k': Check_Key_Present(DBase);
				break;
			case 'g': Get_Record(DBase);
				break;
			case 'e': Erase_Record(DBase);
				break;
			case 's': Print_Size(DBase);
				break;
			case 'u': Print_Sum(DBase);
				break;
			case 'l': Load_Tree_From_File(DBase);
				break;
			case 'v': Save_Tree_To_File(DBase);
				break;
			case 'd': Show_DBase_Structure(DBase);
				break;
			case 'p': Show_Path();
				break;
			case 'h': Print_Height(DBase);
				break;
			case 'r': Initialise(DBase);
				break;
			case 't' : Traversals(DBase);
				break;
			case 'i' : Iterating(DBase);
				break;
			case 'm' : Menu();
				break;
			default   : cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(BST_T DBase) {
	cout	<< "That is it !";
}


void
main () {
	Initialise(DataBase);
	Loop(DataBase);
	Finalise(DataBase);
}