// Ken Brownsey
// 31/8/98
// bst_tree.h
// BST_T

#ifndef BST_H
#define BST_H


#include "data.h"
#include "store.h"

typedef KAPRec_T Element_T;

typedef void  *BST_T;
typedef void *BST_Iterator_T;

// PRE	TRUE
// POST	RETURNS the empty tree
BST_T
Create_Tree();


// PRE	TRUE
// POST	IF Tree is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyTree(BST_T Tree);


// PRE	Tree is not empty
// POST	RETURNS the record in the root
Element_T
Get_Root(BST_T Tree);


// PRE	TRUE
// POST	IF Tree is not empty
//				RETURNS the left sub tree of Tree
//			ELSE
//				RETURNS the empty tree
BST_T
Get_Left(BST_T Tree);



// PRE	TRUE
// POST	IF Tree is not empty
//				RETURNS the right sub tree of Tree
//			ELSE
//				RETURNS the empty tree
BST_T
Get_Right(BST_T Tree);


// PRE	TRUE
// POST	RETURNS the tree whose head is Root and tail is Tree
BST_T
Make_Tree(BST_T Left, Element_T Element, BST_T Right);


// PRE  - 	TRUE
// POST - 	RETURNS the number of nodes allocated
Get_NumberNodes_Allocated();


// PRE	TRUE
// POST	IF Rec is in BST
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_BST_Present_R(Number_T Number, BST_T BST);


// PRE	NOT Q_BST_Present_R(Rec, BST)
// POST	RETURNS BST with Rec inserted according to Q_Precedes
void
BST_Insert(BOOLEAN (* Q_Precedes) (Element_T, Element_T), Element_T Rec, BST_T &BST);


// PRE	Q_BST_Present_R(Number, BST)
// POST	returnS record with key value Number from BST
Element_T
BST_Retrieve_R(Number_T Number, BST_T BST);

// PRE	TRUE
// POST	if (Q_BST_Present(Rec, BST)
//				returnS BST with Rec deleted
//			ELSE
//				returnS BST
void
BST_Delete_R(Number_T Number, BST_T &BST);


#endif
