// queue.h
// 7/8/98
// Queue_T based on Sequence_T
// Ken Brownsey

#include "store.h";

typedef void *Queue_T;
typedef KAPRec_T Element_T;

// PRE	TRUE
// POST	RETURNS an initialised Queue_T
Queue_T
Create_Queue();


// PRE	NOT Q_FullQueue(Queue)
// POST 	elements of Queue' = elements of Queue union {Element}
void
EnQueue(Element_T NewElement, Queue_T Queue);


// PRE	TRUE
// POST	IF Queue is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyQueue(Queue_T Queue);


// PRE	TRUE
// POST	IF Queue is full
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_FullQueue(Queue_T Queue);


// PRE	NOT Q_EmptyQueue(Queue)
// POST	Queue' is Queue with the earliest entered
//			element removed
void
DeQueue(Queue_T Queue);

// PRE	NOT Q_EmptyQueue(Queue)
// POST	RETURNS the value of the earliest
//				entered element of Queue *)
Element_T
Front(Queue_T Queue);



//	PRE	Q_EmptyQueue(Queue)
//	POST	all memory allocated to Queue is freed up
// NOTES	Queue will need to be re-initialised
//			with Create_Queue() before being used again
void
Free_Queue(Queue_T Queue);
